# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "event4xi.py">
#<abstract4xi abstract = "Event Management"/>
#<refer4xi reference = "Events"/>
#<verify4xi verification = "10" target = "event4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4moduletesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 

__all__ = [ 'Event4Xi',                   # ACK
            'create2event4xi',            # ACK
            'get2eventinfo4xi',           # ACK
            'release2event4xi',           # ACK
            'retain2event4xi',            # ACK
            'set2event4xi',               # ACK            
            'set2eventcallback4xi',       # ACK         
            'trace2event4xi',             # ACK
            'wait2event4xi'               # ACK
          ]           
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi

# -------------------------------------------------------------------------------------------------
# Event classes and functions from event modules                            
# -------------------------------------------------------------------------------------------------
from apu2event4xi import APU2Event4Xi                                                                 
from bpu2event4xi import BPU2Event4Xi
from cpu2event4xi import CPU2Event4Xi
from dpu2event4xi import DPU2Event4Xi
from epu2event4xi import EPU2Event4Xi
from fpu2event4xi import FPU2Event4Xi
from gpu2event4xi import GPU2Event4Xi
from hpu2event4xi import HPU2Event4Xi
from ipu2event4xi import IPU2Event4Xi
from jpu2event4xi import JPU2Event4Xi
from kpu2event4xi import KPU2Event4Xi
from lpu2event4xi import LPU2Event4Xi
from mpu2event4xi import MPU2Event4Xi
from npu2event4xi import NPU2Event4Xi
from opu2event4xi import OPU2Event4Xi
from ppu2event4xi import PPU2Event4Xi
from qpu2event4xi import QPU2Event4Xi
from rpu2event4xi import RPU2Event4Xi
from spu2event4xi import SPU2Event4Xi
from tpu2event4xi import TPU2Event4Xi
from upu2event4xi import UPU2Event4Xi
from vpu2event4xi import VPU2Event4Xi
from xpu2event4xi import XPU2Event4Xi
from wpu2event4xi import WPU2Event4Xi
from ypu2event4xi import YPU2Event4Xi
from zpu2event4xi import ZPU2Event4Xi


from apu2event4xi import create2event4apu
from bpu2event4xi import create2event4bpu
from cpu2event4xi import create2event4cpu
from dpu2event4xi import create2event4dpu
from epu2event4xi import create2event4epu
from fpu2event4xi import create2event4fpu
from gpu2event4xi import create2event4gpu
from hpu2event4xi import create2event4hpu
from ipu2event4xi import create2event4ipu
from jpu2event4xi import create2event4jpu
from kpu2event4xi import create2event4kpu
from lpu2event4xi import create2event4lpu
from mpu2event4xi import create2event4mpu
from npu2event4xi import create2event4npu
from opu2event4xi import create2event4opu
from ppu2event4xi import create2event4ppu
from qpu2event4xi import create2event4qpu
from rpu2event4xi import create2event4rpu
from spu2event4xi import create2event4spu
from tpu2event4xi import create2event4tpu
from upu2event4xi import create2event4upu
from vpu2event4xi import create2event4vpu
from xpu2event4xi import create2event4xpu
from wpu2event4xi import create2event4wpu
from ypu2event4xi import create2event4ypu
from zpu2event4xi import create2event4zpu


from apu2event4xi import get2eventinfo4apu
from bpu2event4xi import get2eventinfo4bpu
from cpu2event4xi import get2eventinfo4cpu
from dpu2event4xi import get2eventinfo4dpu
from epu2event4xi import get2eventinfo4epu
from fpu2event4xi import get2eventinfo4fpu
from gpu2event4xi import get2eventinfo4gpu
from hpu2event4xi import get2eventinfo4hpu
from ipu2event4xi import get2eventinfo4ipu
from jpu2event4xi import get2eventinfo4jpu
from kpu2event4xi import get2eventinfo4kpu
from lpu2event4xi import get2eventinfo4lpu
from mpu2event4xi import get2eventinfo4mpu
from npu2event4xi import get2eventinfo4npu
from opu2event4xi import get2eventinfo4opu
from ppu2event4xi import get2eventinfo4ppu
from qpu2event4xi import get2eventinfo4qpu
from rpu2event4xi import get2eventinfo4rpu
from spu2event4xi import get2eventinfo4spu
from tpu2event4xi import get2eventinfo4tpu
from upu2event4xi import get2eventinfo4upu
from vpu2event4xi import get2eventinfo4vpu
from xpu2event4xi import get2eventinfo4xpu
from wpu2event4xi import get2eventinfo4wpu
from ypu2event4xi import get2eventinfo4ypu
from zpu2event4xi import get2eventinfo4zpu


from apu2event4xi import release2event4apu
from bpu2event4xi import release2event4bpu
from cpu2event4xi import release2event4cpu
from dpu2event4xi import release2event4dpu
from epu2event4xi import release2event4epu
from fpu2event4xi import release2event4fpu
from gpu2event4xi import release2event4gpu
from hpu2event4xi import release2event4hpu
from ipu2event4xi import release2event4ipu
from jpu2event4xi import release2event4jpu
from kpu2event4xi import release2event4kpu
from lpu2event4xi import release2event4lpu
from mpu2event4xi import release2event4mpu
from npu2event4xi import release2event4npu
from opu2event4xi import release2event4opu
from ppu2event4xi import release2event4ppu
from qpu2event4xi import release2event4qpu
from rpu2event4xi import release2event4rpu
from spu2event4xi import release2event4spu
from tpu2event4xi import release2event4tpu
from upu2event4xi import release2event4upu
from vpu2event4xi import release2event4vpu
from xpu2event4xi import release2event4xpu
from wpu2event4xi import release2event4wpu
from ypu2event4xi import release2event4ypu
from zpu2event4xi import release2event4zpu

from apu2event4xi import retain2event4apu
from bpu2event4xi import retain2event4bpu
from cpu2event4xi import retain2event4cpu
from dpu2event4xi import retain2event4dpu
from epu2event4xi import retain2event4epu
from fpu2event4xi import retain2event4fpu
from gpu2event4xi import retain2event4gpu
from hpu2event4xi import retain2event4hpu
from ipu2event4xi import retain2event4ipu
from jpu2event4xi import retain2event4jpu
from kpu2event4xi import retain2event4kpu
from lpu2event4xi import retain2event4lpu
from mpu2event4xi import retain2event4mpu
from npu2event4xi import retain2event4npu
from opu2event4xi import retain2event4opu
from ppu2event4xi import retain2event4ppu
from qpu2event4xi import retain2event4qpu
from rpu2event4xi import retain2event4rpu
from spu2event4xi import retain2event4spu
from tpu2event4xi import retain2event4tpu
from upu2event4xi import retain2event4upu
from vpu2event4xi import retain2event4vpu
from xpu2event4xi import retain2event4xpu
from wpu2event4xi import retain2event4wpu
from ypu2event4xi import retain2event4ypu
from zpu2event4xi import retain2event4zpu


from apu2event4xi import set2event4apu
from bpu2event4xi import set2event4bpu
from cpu2event4xi import set2event4cpu
from dpu2event4xi import set2event4dpu
from epu2event4xi import set2event4epu
from fpu2event4xi import set2event4fpu
from gpu2event4xi import set2event4gpu
from hpu2event4xi import set2event4hpu
from ipu2event4xi import set2event4ipu
from jpu2event4xi import set2event4jpu
from kpu2event4xi import set2event4kpu
from lpu2event4xi import set2event4lpu
from mpu2event4xi import set2event4mpu
from npu2event4xi import set2event4npu
from opu2event4xi import set2event4opu
from ppu2event4xi import set2event4ppu
from qpu2event4xi import set2event4qpu
from rpu2event4xi import set2event4rpu
from spu2event4xi import set2event4spu
from tpu2event4xi import set2event4tpu
from upu2event4xi import set2event4upu
from vpu2event4xi import set2event4vpu
from xpu2event4xi import set2event4xpu
from wpu2event4xi import set2event4wpu
from ypu2event4xi import set2event4ypu
from zpu2event4xi import set2event4zpu

from apu2event4xi import set2eventcallback4apu
from bpu2event4xi import set2eventcallback4bpu
from cpu2event4xi import set2eventcallback4cpu
from dpu2event4xi import set2eventcallback4dpu
from epu2event4xi import set2eventcallback4epu
from fpu2event4xi import set2eventcallback4fpu
from gpu2event4xi import set2eventcallback4gpu
from hpu2event4xi import set2eventcallback4hpu
from ipu2event4xi import set2eventcallback4ipu
from jpu2event4xi import set2eventcallback4jpu
from kpu2event4xi import set2eventcallback4kpu
from lpu2event4xi import set2eventcallback4lpu
from mpu2event4xi import set2eventcallback4mpu
from npu2event4xi import set2eventcallback4npu
from opu2event4xi import set2eventcallback4opu
from ppu2event4xi import set2eventcallback4ppu
from qpu2event4xi import set2eventcallback4qpu
from rpu2event4xi import set2eventcallback4rpu
from spu2event4xi import set2eventcallback4spu
from tpu2event4xi import set2eventcallback4tpu
from upu2event4xi import set2eventcallback4upu
from vpu2event4xi import set2eventcallback4vpu
from xpu2event4xi import set2eventcallback4xpu
from wpu2event4xi import set2eventcallback4wpu
from ypu2event4xi import set2eventcallback4ypu
from zpu2event4xi import set2eventcallback4zpu


from apu2event4xi import trace2event4apu
from bpu2event4xi import trace2event4bpu
from cpu2event4xi import trace2event4cpu
from dpu2event4xi import trace2event4dpu
from epu2event4xi import trace2event4epu
from fpu2event4xi import trace2event4fpu
from gpu2event4xi import trace2event4gpu
from hpu2event4xi import trace2event4hpu
from ipu2event4xi import trace2event4ipu
from jpu2event4xi import trace2event4jpu
from kpu2event4xi import trace2event4kpu
from lpu2event4xi import trace2event4lpu
from mpu2event4xi import trace2event4mpu
from npu2event4xi import trace2event4npu
from opu2event4xi import trace2event4opu
from ppu2event4xi import trace2event4ppu
from qpu2event4xi import trace2event4qpu
from rpu2event4xi import trace2event4rpu
from spu2event4xi import trace2event4spu
from tpu2event4xi import trace2event4tpu
from upu2event4xi import trace2event4upu
from vpu2event4xi import trace2event4vpu
from xpu2event4xi import trace2event4xpu
from wpu2event4xi import trace2event4wpu
from ypu2event4xi import trace2event4ypu
from zpu2event4xi import trace2event4zpu

from apu2event4xi import wait2event4apu
from bpu2event4xi import wait2event4bpu
from cpu2event4xi import wait2event4cpu
from dpu2event4xi import wait2event4dpu
from epu2event4xi import wait2event4epu
from fpu2event4xi import wait2event4fpu
from gpu2event4xi import wait2event4gpu
from hpu2event4xi import wait2event4hpu
from ipu2event4xi import wait2event4ipu
from jpu2event4xi import wait2event4jpu
from kpu2event4xi import wait2event4kpu
from lpu2event4xi import wait2event4lpu
from mpu2event4xi import wait2event4mpu
from npu2event4xi import wait2event4npu
from opu2event4xi import wait2event4opu
from ppu2event4xi import wait2event4ppu
from qpu2event4xi import wait2event4qpu
from rpu2event4xi import wait2event4rpu
from spu2event4xi import wait2event4spu
from tpu2event4xi import wait2event4tpu
from upu2event4xi import wait2event4upu
from vpu2event4xi import wait2event4vpu
from xpu2event4xi import wait2event4xpu
from wpu2event4xi import wait2event4wpu
from ypu2event4xi import wait2event4ypu
from zpu2event4xi import wait2event4zpu

# -------------------------------------------------------------------------------------------------
# Context modules                           
# -------------------------------------------------------------------------------------------------
from apu2context4xi import APU2Context4Xi                                                                           
from bpu2context4xi import BPU2Context4Xi
from cpu2context4xi import CPU2Context4Xi
from dpu2context4xi import DPU2Context4Xi
from epu2context4xi import EPU2Context4Xi
from fpu2context4xi import FPU2Context4Xi
from gpu2context4xi import GPU2Context4Xi
from hpu2context4xi import HPU2Context4Xi
from ipu2context4xi import IPU2Context4Xi
from jpu2context4xi import JPU2Context4Xi
from kpu2context4xi import KPU2Context4Xi
from lpu2context4xi import LPU2Context4Xi
from mpu2context4xi import MPU2Context4Xi
from npu2context4xi import NPU2Context4Xi
from opu2context4xi import OPU2Context4Xi
from ppu2context4xi import PPU2Context4Xi
from qpu2context4xi import QPU2Context4Xi
from rpu2context4xi import RPU2Context4Xi
from spu2context4xi import SPU2Context4Xi
from tpu2context4xi import TPU2Context4Xi
from upu2context4xi import UPU2Context4Xi
from vpu2context4xi import VPU2Context4Xi
from xpu2context4xi import XPU2Context4Xi
from wpu2context4xi import WPU2Context4Xi
from ypu2context4xi import YPU2Context4Xi
from zpu2context4xi import ZPU2Context4Xi

from apu2context4xi import create2context4apu 
from bpu2context4xi import create2context4bpu 
from cpu2context4xi import create2context4cpu 
from dpu2context4xi import create2context4dpu 
from epu2context4xi import create2context4epu 
from fpu2context4xi import create2context4fpu 
from gpu2context4xi import create2context4gpu 
from hpu2context4xi import create2context4hpu 
from ipu2context4xi import create2context4ipu 
from jpu2context4xi import create2context4jpu 
from kpu2context4xi import create2context4kpu 
from lpu2context4xi import create2context4lpu 
from mpu2context4xi import create2context4mpu 
from npu2context4xi import create2context4npu 
from opu2context4xi import create2context4opu 
from ppu2context4xi import create2context4ppu 
from qpu2context4xi import create2context4qpu 
from rpu2context4xi import create2context4rpu 
from spu2context4xi import create2context4spu 
from tpu2context4xi import create2context4tpu 
from upu2context4xi import create2context4upu 
from vpu2context4xi import create2context4vpu 
from xpu2context4xi import create2context4xpu 
from wpu2context4xi import create2context4wpu 
from ypu2context4xi import create2context4ypu 
from zpu2context4xi import create2context4zpu 


from apu2context4xi import get2context4apu
from bpu2context4xi import get2context4bpu
from cpu2context4xi import get2context4cpu
from dpu2context4xi import get2context4dpu
from epu2context4xi import get2context4epu
from fpu2context4xi import get2context4fpu
from gpu2context4xi import get2context4gpu
from hpu2context4xi import get2context4hpu
from ipu2context4xi import get2context4ipu
from jpu2context4xi import get2context4jpu
from kpu2context4xi import get2context4kpu
from lpu2context4xi import get2context4lpu
from mpu2context4xi import get2context4mpu
from npu2context4xi import get2context4npu
from opu2context4xi import get2context4opu
from ppu2context4xi import get2context4ppu
from qpu2context4xi import get2context4qpu
from rpu2context4xi import get2context4rpu
from spu2context4xi import get2context4spu
from tpu2context4xi import get2context4tpu
from upu2context4xi import get2context4upu
from vpu2context4xi import get2context4vpu
from xpu2context4xi import get2context4xpu
from wpu2context4xi import get2context4wpu
from ypu2context4xi import get2context4ypu
from zpu2context4xi import get2context4zpu

from apu2context4xi import release2context4apu
from bpu2context4xi import release2context4bpu
from cpu2context4xi import release2context4cpu
from dpu2context4xi import release2context4dpu
from epu2context4xi import release2context4epu
from fpu2context4xi import release2context4fpu
from gpu2context4xi import release2context4gpu
from hpu2context4xi import release2context4hpu
from ipu2context4xi import release2context4ipu
from jpu2context4xi import release2context4jpu
from kpu2context4xi import release2context4kpu
from lpu2context4xi import release2context4lpu
from mpu2context4xi import release2context4mpu
from npu2context4xi import release2context4npu
from opu2context4xi import release2context4opu
from ppu2context4xi import release2context4ppu
from qpu2context4xi import release2context4qpu
from rpu2context4xi import release2context4rpu
from spu2context4xi import release2context4spu
from tpu2context4xi import release2context4tpu
from upu2context4xi import release2context4upu
from vpu2context4xi import release2context4vpu
from xpu2context4xi import release2context4xpu
from wpu2context4xi import release2context4wpu
from ypu2context4xi import release2context4ypu
from zpu2context4xi import release2context4zpu

from apu2context4xi import retain2context4apu
from bpu2context4xi import retain2context4bpu
from cpu2context4xi import retain2context4cpu
from dpu2context4xi import retain2context4dpu
from epu2context4xi import retain2context4epu
from fpu2context4xi import retain2context4fpu
from gpu2context4xi import retain2context4gpu
from hpu2context4xi import retain2context4hpu
from ipu2context4xi import retain2context4ipu
from jpu2context4xi import retain2context4jpu
from kpu2context4xi import retain2context4kpu
from lpu2context4xi import retain2context4lpu
from mpu2context4xi import retain2context4mpu
from npu2context4xi import retain2context4npu
from opu2context4xi import retain2context4opu
from ppu2context4xi import retain2context4ppu
from qpu2context4xi import retain2context4qpu
from rpu2context4xi import retain2context4rpu
from spu2context4xi import retain2context4spu
from tpu2context4xi import retain2context4tpu
from upu2context4xi import retain2context4upu
from vpu2context4xi import retain2context4vpu
from xpu2context4xi import retain2context4xpu
from wpu2context4xi import retain2context4wpu
from ypu2context4xi import retain2context4ypu
from zpu2context4xi import retain2context4zpu

from apu2context4xi import set2context4apu
from bpu2context4xi import set2context4bpu
from cpu2context4xi import set2context4cpu
from dpu2context4xi import set2context4dpu
from epu2context4xi import set2context4epu
from fpu2context4xi import set2context4fpu
from gpu2context4xi import set2context4gpu
from hpu2context4xi import set2context4hpu
from ipu2context4xi import set2context4ipu
from jpu2context4xi import set2context4jpu
from kpu2context4xi import set2context4kpu
from lpu2context4xi import set2context4lpu
from mpu2context4xi import set2context4mpu
from npu2context4xi import set2context4npu
from opu2context4xi import set2context4opu
from ppu2context4xi import set2context4ppu
from qpu2context4xi import set2context4qpu
from rpu2context4xi import set2context4rpu
from spu2context4xi import set2context4spu
from tpu2context4xi import set2context4tpu
from upu2context4xi import set2context4upu
from vpu2context4xi import set2context4vpu
from xpu2context4xi import set2context4xpu
from wpu2context4xi import set2context4wpu
from ypu2context4xi import set2context4ypu
from zpu2context4xi import set2context4zpu



# -------------------------------------------------------------------------------------------------
# Device modules                           
# -------------------------------------------------------------------------------------------------
from apu2device4xi import APU4Xi                                                                                   
from bpu2device4xi import BPU4Xi
from cpu2device4xi import CPU4Xi
from dpu2device4xi import DPU4Xi
from epu2device4xi import EPU4Xi
from fpu2device4xi import FPU4Xi
from gpu2device4xi import GPU4Xi
from hpu2device4xi import HPU4Xi
from ipu2device4xi import IPU4Xi
from jpu2device4xi import JPU4Xi
from kpu2device4xi import KPU4Xi
from lpu2device4xi import LPU4Xi
from mpu2device4xi import MPU4Xi
from npu2device4xi import NPU4Xi
from opu2device4xi import OPU4Xi
from ppu2device4xi import PPU4Xi
from qpu2device4xi import QPU4Xi
from rpu2device4xi import RPU4Xi
from spu2device4xi import SPU4Xi
from tpu2device4xi import TPU4Xi
from upu2device4xi import UPU4Xi
from vpu2device4xi import VPU4Xi
from xpu2device4xi import XPU4Xi
from wpu2device4xi import WPU4Xi
from ypu2device4xi import YPU4Xi
from zpu2device4xi import ZPU4Xi

from apu2device4xi import init2apu4xi 
from bpu2device4xi import init2bpu4xi 
from cpu2device4xi import init2cpu4xi 
from dpu2device4xi import init2dpu4xi 
from epu2device4xi import init2epu4xi 
from fpu2device4xi import init2fpu4xi 
from gpu2device4xi import init2gpu4xi 
from hpu2device4xi import init2hpu4xi 
from ipu2device4xi import init2ipu4xi 
from jpu2device4xi import init2jpu4xi 
from kpu2device4xi import init2kpu4xi 
from lpu2device4xi import init2lpu4xi 
from mpu2device4xi import init2mpu4xi 
from npu2device4xi import init2npu4xi 
from opu2device4xi import init2opu4xi 
from ppu2device4xi import init2ppu4xi 
from qpu2device4xi import init2qpu4xi 
from rpu2device4xi import init2rpu4xi 
from spu2device4xi import init2spu4xi 
from tpu2device4xi import init2tpu4xi 
from upu2device4xi import init2upu4xi 
from vpu2device4xi import init2vpu4xi 
from xpu2device4xi import init2xpu4xi 
from wpu2device4xi import init2wpu4xi 
from ypu2device4xi import init2ypu4xi 
from zpu2device4xi import init2zpu4xi 

from apu2device4xi import set2apu4xi
from bpu2device4xi import set2bpu4xi
from cpu2device4xi import set2cpu4xi
from dpu2device4xi import set2dpu4xi
from epu2device4xi import set2epu4xi
from fpu2device4xi import set2fpu4xi
from gpu2device4xi import set2gpu4xi
from hpu2device4xi import set2hpu4xi
from ipu2device4xi import set2ipu4xi
from jpu2device4xi import set2jpu4xi
from kpu2device4xi import set2kpu4xi
from lpu2device4xi import set2lpu4xi
from mpu2device4xi import set2mpu4xi
from npu2device4xi import set2npu4xi
from opu2device4xi import set2opu4xi
from ppu2device4xi import set2ppu4xi
from qpu2device4xi import set2qpu4xi
from rpu2device4xi import set2rpu4xi
from spu2device4xi import set2spu4xi
from tpu2device4xi import set2tpu4xi
from upu2device4xi import set2upu4xi
from vpu2device4xi import set2vpu4xi
from xpu2device4xi import set2xpu4xi
from wpu2device4xi import set2wpu4xi
from ypu2device4xi import set2ypu4xi
from zpu2device4xi import set2zpu4xi

from apu2device4xi import get2apu4xi
from bpu2device4xi import get2bpu4xi
from cpu2device4xi import get2cpu4xi
from dpu2device4xi import get2dpu4xi
from epu2device4xi import get2epu4xi
from fpu2device4xi import get2fpu4xi
from gpu2device4xi import get2gpu4xi
from hpu2device4xi import get2hpu4xi
from ipu2device4xi import get2ipu4xi
from jpu2device4xi import get2jpu4xi
from kpu2device4xi import get2kpu4xi
from lpu2device4xi import get2lpu4xi
from mpu2device4xi import get2mpu4xi
from npu2device4xi import get2npu4xi
from opu2device4xi import get2opu4xi
from ppu2device4xi import get2ppu4xi
from qpu2device4xi import get2qpu4xi
from rpu2device4xi import get2rpu4xi
from spu2device4xi import get2spu4xi
from tpu2device4xi import get2tpu4xi
from upu2device4xi import get2upu4xi
from vpu2device4xi import get2vpu4xi
from xpu2device4xi import get2xpu4xi
from wpu2device4xi import get2wpu4xi
from ypu2device4xi import get2ypu4xi
from zpu2device4xi import get2zpu4xi



# -------------------------------------------------------------------------------------------------
# Platform                           
# -------------------------------------------------------------------------------------------------
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from queue4xi import Queue4Xi 
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global event4xi
      
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2event4xi" usage = " 
#
# print('=' *33)          
# print('(Step 2A/33) OF EVENT5TEST - TRYING TO CREATE EVENT ', time4xi())   
# print('=' *33)        
# try:
#     cc2xi = create2event4xi()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
#     print('(Step 2B/33) OF EVENT5TEST - CREATED EVENT: ', cc2xi)                                  
#     # 
# except:
#     print('(Step 2Z/33) OF EVENT5TEST *** FAILED TO CREATE EVENT', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def create2event4xi(task4create2event=None):

    '''
    initializes event4xi
    '''
    global event4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2event4xi"
    method2print = "create2event4xi"

    message2print = "{(Step 1A/33) started" + "; create2event4xi-started: " + str(create2event4xi)  + "; time: " + time4xi() + "}"   
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4create2event-to-create2event4xi: " + str(task4create2event) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 

 
    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4create2event is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - EVENT NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if event4xi is None:                                                                                       
                event4xi = {} 
                code2ack  = code2ack + '1D-'
        except:
            event4xi = {} 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4create2event-try-by-create2event4xi: " + str(task4create2event)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 
    
 

    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES 
            # ----------------------------------------------------------------------------------------- 
        
            event4xi = {} 
            event4xi['APU'] = create2event4apu()                                                                        
            event4xi['BPU'] = create2event4bpu()   
            event4xi['CPU'] = create2event4cpu()   
            event4xi['DPU'] = create2event4dpu()   
            event4xi['EPU'] = create2event4epu()   
            event4xi['FPU'] = create2event4fpu()   
            event4xi['GPU'] = create2event4gpu()   
            event4xi['HPU'] = create2event4hpu()   
            event4xi['IPU'] = create2event4ipu()   
            event4xi['JPU'] = create2event4jpu()   
            event4xi['KPU'] = create2event4kpu()   
            event4xi['LPU'] = create2event4lpu()   
            event4xi['MPU'] = create2event4mpu()   
            event4xi['NPU'] = create2event4npu()   
            event4xi['OPU'] = create2event4opu()   
            event4xi['PPU'] = create2event4ppu()   
            event4xi['QPU'] = create2event4qpu()   
            event4xi['RPU'] = create2event4rpu()   
            event4xi['SPU'] = create2event4spu()   
            event4xi['TPU'] = create2event4tpu()   
            event4xi['UPU'] = create2event4upu()   
            event4xi['VPU'] = create2event4vpu()   
            event4xi['XPU'] = create2event4xpu()   
            event4xi['WPU'] = create2event4wpu()   
            event4xi['YPU'] = create2event4ypu()   
            event4xi['ZPU'] = create2event4zpu()   
                                                                                                                                                                                                                                                                                                            
                                         
            message2print = "{(Step 3AA/33) initialized" + "; event4apu-initialized-by-create2event4xi to: " + str(event4xi['APU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AB/33) initialized" + "; event4bpu-initialized-by-create2event4xi to: " + str(event4xi['BPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AC/33) initialized" + "; event4cpu-initialized-by-create2event4xi to: " + str(event4xi['CPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AD/33) initialized" + "; event4dpu-initialized-by-create2event4xi to: " + str(event4xi['DPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AE/33) initialized" + "; event4epu-initialized-by-create2event4xi to: " + str(event4xi['EPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #                         
            message2print = "{(Step 3AF/33) initialized" + "; event4fpu-initialized-by-create2event4xi to: " + str(event4xi['FPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #             
            message2print = "{(Step 3AG/33) initialized" + "; event4gpu-initialized-by-create2event4xi to: " + str(event4xi['GPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            message2print = "{(Step 3AH/33) initialized" + "; event4hpu-initialized-by-create2event4xi to: " + str(event4xi['HPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
                                         
            message2print = "{(Step 3AI/33) initialized" + "; event4ipu-initialized-by-create2event4xi to: " + str(event4xi['IPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AJ/33) initialized" + "; event4jpu-initialized-by-create2event4xi to: " + str(event4xi['JPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AK/33) initialized" + "; event4kpu-initialized-by-create2event4xi to: " + str(event4xi['KPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AL/33) initialized" + "; event4lpu-initialized-by-create2event4xi to: " + str(event4xi['LPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AM/33) initialized" + "; event4mpu-initialized-by-create2event4xi to: " + str(event4xi['MPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #                         
            message2print = "{(Step 3AN/33) initialized" + "; event4npu-initialized-by-create2event4xi to: " + str(event4xi['NPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #             
            message2print = "{(Step 3AO/33) initialized" + "; event4opu-initialized-by-create2event4xi to: " + str(event4xi['OPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            message2print = "{(Step 3AP/33) initialized" + "; event4ppu-initialized-by-create2event4xi to: " + str(event4xi['PPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
                                         
            message2print = "{(Step 3AQ/33) initialized" + "; event4qpu-initialized-by-create2event4xi to: " + str(event4xi['QPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AR/33) initialized" + "; event4rpu-initialized-by-create2event4xi to: " + str(event4xi['RPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AS/33) initialized" + "; event4spu-initialized-by-create2event4xi to: " + str(event4xi['SPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AT/33) initialized" + "; event4tpu-initialized-by-create2event4xi to: " + str(event4xi['TPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #  
            message2print = "{(Step 3AU/33) initialized" + "; event4upu-initialized-by-create2event4xi to: " + str(event4xi['UPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #                         
            message2print = "{(Step 3AV/33) initialized" + "; event4vpu-initialized-by-create2event4xi to: " + str(event4xi['VPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #             
            message2print = "{(Step 3AW/33) initialized" + "; event4wpu-initialized-by-create2event4xi to: " + str(event4xi['WPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            message2print = "{(Step 3AX/33) initialized" + "; event4xpu-initialized-by-create2event4xi to: " + str(event4xi['XPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            #             
            message2print = "{(Step 3AY/33) initialized" + "; event4ypu-initialized-by-create2event4xi to: " + str(event4xi['YPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            message2print = "{(Step 3AZ/33) initialized" + "; event4zpu-initialized-by-create2event4xi to: " + str(event4xi['ZPU'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # {'CODE2ERROR': 0, 
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4zpu-failed ; time: 04:04:44 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4zpu', 'METHOD': 'create2event4zpu'}, 
            #  'FUNCTION2CALLBACK': <function trace2event4zpu at 0x00000000045B0748>, 
            #  'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 
            #  'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006157400>, 
            #  'NACK2RETURN': ' ', 
            #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4zpu-failed ; time: 04:04:44 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4zpu', 'METHOD': 'create2context4zpu'}, 'FUNCTION2CALLBACK': <function trace2context4zpu at 0x000000000455A548>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4zpu-failed ; time: 04:04:44 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4zpu', 'METHOD': 'create2commandqueue4zpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4zpu at 0x0000000004598F48>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006208B70>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4zpu-failed ; time: 04:04:44 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4zpu', 'METHOD': 'create2context4zpu'}, 'FUNCTION2CALLBACK': <function trace2context4zpu at 0x000000000455A548>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_ZPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 2024>, <read-write PipeConnection, handle 2028>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_ZPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1992>, <read-write PipeConnection, handle 1996>)}; time: 04:04:44 08/26/11 Pacific Daylight Time}
 
                                                                                                
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; event4xi-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    

        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            event4xi['APU'] = create2event4apu(task4create2event['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2event4xi to: " + str(event4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            event4xi['BPU'] = create2event4bpu(task4create2event['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2event4xi to: " + str(event4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            event4xi['CPU'] = create2event4cpu(task4create2event['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2event4xi to: " + str(event4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            event4xi['DPU'] = create2event4dpu(task4create2event['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2event4xi to: " + str(event4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            event4xi['EPU'] = create2event4epu(task4create2event['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2event4xi to: " + str(event4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            event4xi['FPU'] = create2event4fpu(task4create2event['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2event4xi to: " + str(event4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            event4xi['GPU'] = create2event4gpu(task4create2event['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2event4xi to: " + str(event4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            event4xi['HPU'] = create2event4hpu(task4create2event['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2event4xi to: " + str(event4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            event4xi['IPU'] = create2event4ipu(task4create2event['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2event4xi to: " + str(event4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            event4xi['JPU'] = create2event4jpu(task4create2event['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2event4xi to: " + str(event4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            event4xi['KPU'] = create2event4kpu(task4create2event['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2event4xi to: " + str(event4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            event4xi['LPU'] = create2event4lpu(task4create2event['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2event4xi to: " + str(event4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            event4xi['MPU'] = create2event4mpu(task4create2event['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2event4xi to: " + str(event4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            event4xi['NPU'] = create2event4npu(task4create2event['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2event4xi to: " + str(event4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            event4xi['OPU'] = create2event4opu(task4create2event['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2event4xi to: " + str(event4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            event4xi['PPU'] = create2event4ppu(task4create2event['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2event4xi to: " + str(event4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            event4xi['QPU'] = create2event4qpu(task4create2event['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2event4xi to: " + str(event4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            event4xi['RPU'] = create2event4rpu(task4create2event['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2event4xi to: " + str(event4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            event4xi['SPU'] = create2event4spu(task4create2event['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2event4xi to: " + str(event4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            event4xi['TPU'] = create2event4tpu(task4create2event['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2event4xi to: " + str(event4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            event4xi['UPU'] = create2event4upu(task4create2event['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2event4xi to: " + str(event4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            event4xi['VPU'] = create2event4vpu(task4create2event['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2event4xi to: " + str(event4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            event4xi['WPU'] = create2event4wpu(task4create2event['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2event4xi to: " + str(event4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            event4xi['XPU'] = create2event4xpu(task4create2event['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2event4xi to: " + str(event4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            event4xi['YPU'] = create2event4ypu(task4create2event['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2event4xi to: " + str(event4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            event4xi['ZPU'] = create2event4zpu(task4create2event['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2event4xi to: " + str(event4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    
    message2print = "{(Step 33/33) returning" + "; event4xi-returning-by-create2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'DPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 04:04:42 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4dpu', 'METHOD': 'create2event4dpu'}, 'FUNCTION2CALLBACK': <function trace2event4dpu at 0x0000000003C3C948>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004CACC18>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:04:42 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FD8748>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4dpu-failed ; time: 04:04:42 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4dpu', 'METHOD': 'create2commandqueue4dpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4dpu at 0x0000000003C3C1C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004D29CF8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:04:42 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FD8748>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 612>, <read-write PipeConnection, handle 616>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 580>, <read-write PipeConnection, handle 584>)}, 
    #  'EPU': ...

    return event4xi
            
#</function4xi> 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2eventcallback4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF EVENT5TEST - TRYING TO SET CALLBACK TO EVENT4XI ', time4xi())
#     try:                               
#         response4set2eventcallback = set2eventcallback4xi()                                                       
#         print('(Step 4B/33) OF EVENT5TEST - RESPONSE4SET2EVENTCALLBACK : ', response4set2eventcallback) 
#     except:
#         print('(Step 4Z1/33) OF EVENT5TEST *** FAILED TO SET CALLBACK TO EVENT4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def set2eventcallback4xi(task4set2eventcallback=None):

    '''
    sets event4xi
    '''
    global event4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2eventcallback4xi"
    method2print = "set2eventcallback4xi"

    message2print = "{(Step 1A/33) started" + "; set2eventcallback4xi-started: " + str(set2eventcallback4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
             
    message2print = "{(Step 1B/33) passed" + "; task4set2eventcallback-to-set2eventcallback4xi: " + str(task4set2eventcallback) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    
 
    code2ack  = ' '
    code2nack = ' '

    if event4xi is None:
        event4xi = create2event4xi()                                                                            # CREATE EVENT
                                
        message2print = "{(Step 1C/33) set" + "; event4xi-set-by-set2eventcallback4xi to: " + str(event4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A/33) passing" + "; task-passing-to-set2eventcallback4apu: " + str(task4set2eventcallback['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['APU'] = set2eventcallback4apu(task4set2eventcallback['APU'])                                                      # 
         
        message2print = "{(Step A1/33) set" + "; apu-event-set-by-set2eventcallback4apu to: " + str(event4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'A1-'
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2eventcallback4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B/33) passing" + "; task-passing-to-set2eventcallback4bpu: " + str(task4set2eventcallback['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['BPU'] = set2eventcallback4bpu(task4set2eventcallback['BPU'])                                                      # 
         
        message2print = "{(Step B1/33) set" + "; bpu-event-set-by-set2eventcallback4bpu to: " + str(event4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'B1-'
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2eventcallback4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C/33) passing" + "; task-passing-to-set2eventcallback4cpu: " + str(task4set2eventcallback['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['CPU'] = set2eventcallback4cpu(task4set2eventcallback['CPU'])                                                      # 
         
        message2print = "{(Step C1/33) set" + "; cpu-event-set-by-set2eventcallback4cpu to: " + str(event4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'C1-'
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2eventcallback4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D/33) passing" + "; task-passing-to-set2eventcallback4dpu: " + str(task4set2eventcallback['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['DPU'] = set2eventcallback4dpu(task4set2eventcallback['DPU'])                                                      # 
         
        message2print = "{(Step D1/33) set" + "; dpu-event-set-by-set2eventcallback4dpu to: " + str(event4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'D1-'
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2eventcallback4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E/33) passing" + "; task-passing-to-set2eventcallback4epu: " + str(task4set2eventcallback['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['EPU'] = set2eventcallback4epu(task4set2eventcallback['EPU'])                                                      # 
         
        message2print = "{(Step E1/33) set" + "; epu-event-set-by-set2eventcallback4epu to: " + str(event4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'E1-'
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2eventcallback4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F/33) passing" + "; task-passing-to-set2eventcallback4fpu: " + str(task4set2eventcallback['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['FPU'] = set2eventcallback4fpu(task4set2eventcallback['FPU'])                                                      # 
         
        message2print = "{(Step F1/33) set" + "; fpu-event-set-by-set2eventcallback4fpu to: " + str(event4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'F1-'
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2eventcallback4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G/33) passing" + "; task-passing-to-set2eventcallback4gpu: " + str(task4set2eventcallback['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['GPU'] = set2eventcallback4gpu(task4set2eventcallback['GPU'])                                                      # 
         
        message2print = "{(Step G1/33) set" + "; gpu-event-set-by-set2eventcallback4gpu to: " + str(event4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'G1-'
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2eventcallback4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H/33) passing" + "; task-passing-to-set2eventcallback4hpu: " + str(task4set2eventcallback['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['HPU'] = set2eventcallback4hpu(task4set2eventcallback['HPU'])                                                      # 
         
        message2print = "{(Step H1/33) set" + "; hpu-event-set-by-set2eventcallback4hpu to: " + str(event4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'H1-'
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2eventcallback4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I/33) passing" + "; task-passing-to-set2eventcallback4ipu: " + str(task4set2eventcallback['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['IPU'] = set2eventcallback4ipu(task4set2eventcallback['IPU'])                                                      # 
         
        message2print = "{(Step I1/33) set" + "; ipu-event-set-by-set2eventcallback4ipu to: " + str(event4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'I1-'
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2eventcallback4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J/33) passing" + "; task-passing-to-set2eventcallback4jpu: " + str(task4set2eventcallback['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['JPU'] = set2eventcallback4jpu(task4set2eventcallback['JPU'])                                                      # 
         
        message2print = "{(Step J1/33) set" + "; jpu-event-set-by-set2eventcallback4jpu to: " + str(event4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'J1-'
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2eventcallback4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K/33) passing" + "; task-passing-to-set2eventcallback4kpu: " + str(task4set2eventcallback['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['KPU'] = set2eventcallback4kpu(task4set2eventcallback['KPU'])                                                      # 
         
        message2print = "{(Step K1/33) set" + "; kpu-event-set-by-set2eventcallback4kpu to: " + str(event4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'K1-'
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2eventcallback4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L/33) passing" + "; task-passing-to-set2eventcallback4lpu: " + str(task4set2eventcallback['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['LPU'] = set2eventcallback4lpu(task4set2eventcallback['LPU'])                                                      # 
         
        message2print = "{(Step L1/33) set" + "; lpu-event-set-by-set2eventcallback4lpu to: " + str(event4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + '1-'
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2eventcallback4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M/33) passing" + "; task-passing-to-set2eventcallback4mpu: " + str(task4set2eventcallback['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['MPU'] = set2eventcallback4mpu(task4set2eventcallback['MPU'])                                                      # 
         
        message2print = "{(Step M1/33) set" + "; mpu-event-set-by-set2eventcallback4mpu to: " + str(event4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'M1-'
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2eventcallback4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N/33) passing" + "; task-passing-to-set2eventcallback4npu: " + str(task4set2eventcallback['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['NPU'] = set2eventcallback4npu(task4set2eventcallback['NPU'])                                                      # 
         
        message2print = "{(Step N1/33) set" + "; npu-event-set-by-set2eventcallback4npu to: " + str(event4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'N1-'
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2eventcallback4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O/33) passing" + "; task-passing-to-set2eventcallback4opu: " + str(task4set2eventcallback['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['OPU'] = set2eventcallback4opu(task4set2eventcallback['OPU'])                                                      # 
         
        message2print = "{(Step O1/33) set" + "; opu-event-set-by-set2eventcallback4opu to: " + str(event4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'O1-'
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2eventcallback4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P/33) passing" + "; task-passing-to-set2eventcallback4ppu: " + str(task4set2eventcallback['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['PPU'] = set2eventcallback4ppu(task4set2eventcallback['PPU'])                                                      # 
         
        message2print = "{(Step P1/33) set" + "; ppu-event-set-by-set2eventcallback4ppu to: " + str(event4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'P1-'
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2eventcallback4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q/33) passing" + "; task-passing-to-set2eventcallback4qpu: " + str(task4set2eventcallback['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['QPU'] = set2eventcallback4qpu(task4set2eventcallback['QPU'])                                                      # 
         
        message2print = "{(Step Q1/33) set" + "; qpu-event-set-by-set2eventcallback4qpu to: " + str(event4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Q1-'
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2eventcallback4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R/33) passing" + "; task-passing-to-set2eventcallback4rpu: " + str(task4set2eventcallback['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['RPU'] = set2eventcallback4rpu(task4set2eventcallback['RPU'])                                                      # 
         
        message2print = "{(Step R1/33) set" + "; rpu-event-set-by-set2eventcallback4rpu to: " + str(event4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'R1-'
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2eventcallback4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S/33) passing" + "; task-passing-to-set2eventcallback4spu: " + str(task4set2eventcallback['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['SPU'] = set2eventcallback4spu(task4set2eventcallback['SPU'])                                                      # 
         
        message2print = "{(Step S1/33) set" + "; spu-event-set-by-set2eventcallback4spu to: " + str(event4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'S1-'
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2eventcallback4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T/33) passing" + "; task-passing-to-set2eventcallback4tpu: " + str(task4set2eventcallback['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['TPU'] = set2eventcallback4tpu(task4set2eventcallback['TPU'])                                                      # 
         
        message2print = "{(Step T1/33) set" + "; tpu-event-set-by-set2eventcallback4tpu to: " + str(event4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'T1-'
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2eventcallback4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U/33) passing" + "; task-passing-to-set2eventcallback4upu: " + str(task4set2eventcallback['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['UPU'] = set2eventcallback4upu(task4set2eventcallback['UPU'])                                                      # 
         
        message2print = "{(Step U1/33) set" + "; upu-event-set-by-set2eventcallback4upu to: " + str(event4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'U1-'
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2eventcallback4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V/33) passing" + "; task-passing-to-set2eventcallback4vpu: " + str(task4set2eventcallback['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['VPU'] = set2eventcallback4vpu(task4set2eventcallback['VPU'])                                                      # 
         
        message2print = "{(Step V1/33) set" + "; vpu-event-set-by-set2eventcallback4vpu to: " + str(event4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'V1-'
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2eventcallback4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W/33) passing" + "; task-passing-to-set2eventcallback4wpu: " + str(task4set2eventcallback['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['WPU'] = set2eventcallback4wpu(task4set2eventcallback['WPU'])                                                      # 
         
        message2print = "{(Step W1/33) set" + "; wpu-event-set-by-set2eventcallback4wpu to: " + str(event4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'W1-'
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2eventcallback4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X/33) passing" + "; task-passing-to-set2eventcallback4xpu: " + str(task4set2eventcallback['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['XPU'] = set2eventcallback4xpu(task4set2eventcallback['XPU'])                                                      # 
         
        message2print = "{(Step X1/33) set" + "; xpu-event-set-by-set2eventcallback4xpu to: " + str(event4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'X1-'
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2eventcallback4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y/33) passing" + "; task-passing-to-set2eventcallback4ypu: " + str(task4set2eventcallback['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['YPU'] = set2eventcallback4ypu(task4set2eventcallback['YPU'])                                                      # 
         
        message2print = "{(Step Y1/33) set" + "; ypu-event-set-by-set2eventcallback4ypu to: " + str(event4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Y1-'
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2eventcallback4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z/33) passing" + "; task-passing-to-set2eventcallback4zpu: " + str(task4set2eventcallback['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['ZPU'] = set2eventcallback4zpu(task4set2eventcallback['ZPU'])                                                      # 
         
        message2print = "{(Step Z1/33) set" + "; zpu-event-set-by-set2eventcallback4zpu to: " + str(event4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Z1-'
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2eventcallback4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; event4xi-returning-by-set2eventcallback4xi: " + str(event4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    
    return event4xi

            
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2event4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF EVENT5TEST - TRYING TO SET EVENT4XI ', time4xi())
#     try:                               
#         response4set2event = set2event4xi()                                                       
#         print('(Step 4B/33) OF EVENT5TEST - RESPONSE4SET2EVENT : ', response4set2event) 
#     except:
#         print('(Step 4Z1/33) OF EVENT5TEST *** FAILED TO SET EVENT4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def set2event4xi(task4set2event=None):

    '''
    sets event4xi
    '''
    global event4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2event4xi"
    method2print = "set2event4xi"

    message2print = "{(Step 1A/33) started" + "; set2event4xi-started: " + str(set2event4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
             
    message2print = "{(Step 1B/33) passed" + "; task4set2event-to-set2event4xi: " + str(task4set2event) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    
 
    code2ack  = ' '
    code2nack = ' '

    if event4xi is None:
        event4xi = create2event4xi()                                                                            # CREATE EVENT
                                
        message2print = "{(Step 1C/33) set" + "; event4xi-set-by-set2event4xi to: " + str(event4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A/33) passing" + "; task-passing-to-set2event4apu: " + str(task4set2event['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['APU'] = set2event4apu(task4set2event['APU'])                                                      # 
         
        message2print = "{(Step A1/33) set" + "; apu-event-set-by-set2event4apu to: " + str(event4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'A1-'
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2event4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B/33) passing" + "; task-passing-to-set2event4bpu: " + str(task4set2event['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['BPU'] = set2event4bpu(task4set2event['BPU'])                                                      # 
         
        message2print = "{(Step B1/33) set" + "; bpu-event-set-by-set2event4bpu to: " + str(event4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'B1-'
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2event4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C/33) passing" + "; task-passing-to-set2event4cpu: " + str(task4set2event['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['CPU'] = set2event4cpu(task4set2event['CPU'])                                                      # 
         
        message2print = "{(Step C1/33) set" + "; cpu-event-set-by-set2event4cpu to: " + str(event4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'C1-'
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2event4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D/33) passing" + "; task-passing-to-set2event4dpu: " + str(task4set2event['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['DPU'] = set2event4dpu(task4set2event['DPU'])                                                      # 
         
        message2print = "{(Step D1/33) set" + "; dpu-event-set-by-set2event4dpu to: " + str(event4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'D1-'
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2event4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E/33) passing" + "; task-passing-to-set2event4epu: " + str(task4set2event['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['EPU'] = set2event4epu(task4set2event['EPU'])                                                      # 
         
        message2print = "{(Step E1/33) set" + "; epu-event-set-by-set2event4epu to: " + str(event4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'E1-'
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2event4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F/33) passing" + "; task-passing-to-set2event4fpu: " + str(task4set2event['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['FPU'] = set2event4fpu(task4set2event['FPU'])                                                      # 
         
        message2print = "{(Step F1/33) set" + "; fpu-event-set-by-set2event4fpu to: " + str(event4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'F1-'
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2event4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G/33) passing" + "; task-passing-to-set2event4gpu: " + str(task4set2event['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['GPU'] = set2event4gpu(task4set2event['GPU'])                                                      # 
         
        message2print = "{(Step G1/33) set" + "; gpu-event-set-by-set2event4gpu to: " + str(event4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'G1-'
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2event4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H/33) passing" + "; task-passing-to-set2event4hpu: " + str(task4set2event['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['HPU'] = set2event4hpu(task4set2event['HPU'])                                                      # 
         
        message2print = "{(Step H1/33) set" + "; hpu-event-set-by-set2event4hpu to: " + str(event4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'H1-'
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2event4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I/33) passing" + "; task-passing-to-set2event4ipu: " + str(task4set2event['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['IPU'] = set2event4ipu(task4set2event['IPU'])                                                      # 
         
        message2print = "{(Step I1/33) set" + "; ipu-event-set-by-set2event4ipu to: " + str(event4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'I1-'
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2event4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J/33) passing" + "; task-passing-to-set2event4jpu: " + str(task4set2event['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['JPU'] = set2event4jpu(task4set2event['JPU'])                                                      # 
         
        message2print = "{(Step J1/33) set" + "; jpu-event-set-by-set2event4jpu to: " + str(event4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'J1-'
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2event4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K/33) passing" + "; task-passing-to-set2event4kpu: " + str(task4set2event['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['KPU'] = set2event4kpu(task4set2event['KPU'])                                                      # 
         
        message2print = "{(Step K1/33) set" + "; kpu-event-set-by-set2event4kpu to: " + str(event4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'K1-'
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2event4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L/33) passing" + "; task-passing-to-set2event4lpu: " + str(task4set2event['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['LPU'] = set2event4lpu(task4set2event['LPU'])                                                      # 
         
        message2print = "{(Step L1/33) set" + "; lpu-event-set-by-set2event4lpu to: " + str(event4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + '1-'
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2event4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M/33) passing" + "; task-passing-to-set2event4mpu: " + str(task4set2event['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['MPU'] = set2event4mpu(task4set2event['MPU'])                                                      # 
         
        message2print = "{(Step M1/33) set" + "; mpu-event-set-by-set2event4mpu to: " + str(event4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'M1-'
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2event4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N/33) passing" + "; task-passing-to-set2event4npu: " + str(task4set2event['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['NPU'] = set2event4npu(task4set2event['NPU'])                                                      # 
         
        message2print = "{(Step N1/33) set" + "; npu-event-set-by-set2event4npu to: " + str(event4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'N1-'
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2event4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O/33) passing" + "; task-passing-to-set2event4opu: " + str(task4set2event['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['OPU'] = set2event4opu(task4set2event['OPU'])                                                      # 
         
        message2print = "{(Step O1/33) set" + "; opu-event-set-by-set2event4opu to: " + str(event4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'O1-'
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2event4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P/33) passing" + "; task-passing-to-set2event4ppu: " + str(task4set2event['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['PPU'] = set2event4ppu(task4set2event['PPU'])                                                      # 
         
        message2print = "{(Step P1/33) set" + "; ppu-event-set-by-set2event4ppu to: " + str(event4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'P1-'
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2event4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q/33) passing" + "; task-passing-to-set2event4qpu: " + str(task4set2event['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['QPU'] = set2event4qpu(task4set2event['QPU'])                                                      # 
         
        message2print = "{(Step Q1/33) set" + "; qpu-event-set-by-set2event4qpu to: " + str(event4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Q1-'
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2event4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R/33) passing" + "; task-passing-to-set2event4rpu: " + str(task4set2event['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['RPU'] = set2event4rpu(task4set2event['RPU'])                                                      # 
         
        message2print = "{(Step R1/33) set" + "; rpu-event-set-by-set2event4rpu to: " + str(event4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'R1-'
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2event4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S/33) passing" + "; task-passing-to-set2event4spu: " + str(task4set2event['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['SPU'] = set2event4spu(task4set2event['SPU'])                                                      # 
         
        message2print = "{(Step S1/33) set" + "; spu-event-set-by-set2event4spu to: " + str(event4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'S1-'
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2event4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T/33) passing" + "; task-passing-to-set2event4tpu: " + str(task4set2event['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['TPU'] = set2event4tpu(task4set2event['TPU'])                                                      # 
         
        message2print = "{(Step T1/33) set" + "; tpu-event-set-by-set2event4tpu to: " + str(event4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'T1-'
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2event4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U/33) passing" + "; task-passing-to-set2event4upu: " + str(task4set2event['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['UPU'] = set2event4upu(task4set2event['UPU'])                                                      # 
         
        message2print = "{(Step U1/33) set" + "; upu-event-set-by-set2event4upu to: " + str(event4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'U1-'
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2event4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V/33) passing" + "; task-passing-to-set2event4vpu: " + str(task4set2event['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['VPU'] = set2event4vpu(task4set2event['VPU'])                                                      # 
         
        message2print = "{(Step V1/33) set" + "; vpu-event-set-by-set2event4vpu to: " + str(event4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'V1-'
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2event4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W/33) passing" + "; task-passing-to-set2event4wpu: " + str(task4set2event['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['WPU'] = set2event4wpu(task4set2event['WPU'])                                                      # 
         
        message2print = "{(Step W1/33) set" + "; wpu-event-set-by-set2event4wpu to: " + str(event4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'W1-'
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2event4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X/33) passing" + "; task-passing-to-set2event4xpu: " + str(task4set2event['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['XPU'] = set2event4xpu(task4set2event['XPU'])                                                      # 
         
        message2print = "{(Step X1/33) set" + "; xpu-event-set-by-set2event4xpu to: " + str(event4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'X1-'
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2event4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y/33) passing" + "; task-passing-to-set2event4ypu: " + str(task4set2event['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['YPU'] = set2event4ypu(task4set2event['YPU'])                                                      # 
         
        message2print = "{(Step Y1/33) set" + "; ypu-event-set-by-set2event4ypu to: " + str(event4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Y1-'
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2event4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z/33) passing" + "; task-passing-to-set2event4zpu: " + str(task4set2event['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['ZPU'] = set2event4zpu(task4set2event['ZPU'])                                                      # 
         
        message2print = "{(Step Z1/33) set" + "; zpu-event-set-by-set2event4zpu to: " + str(event4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Z1-'
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2event4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; event4xi-returning-by-set2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    
    return event4xi

            
#</function4xi>


 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2event4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF EVENT5TEST - TRYING TO RETAIN EVENT4XI ', time4xi())
#     try:                               
#         response4retain2event = retain2event4xi()                                                       
#         print('(Step 4B/33) OF EVENT5TEST - RESPONSE4SET2EVENT : ', response4retain2event) 
#     except:
#         print('(Step 4Z1/33) OF EVENT5TEST *** FAILED TO RETAIN EVENT4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def retain2event4xi(task4retain2event=None):

    '''
    retains event4xi
    '''
    global event4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2event4xi"
    method2print = "retain2event4xi"

    message2print = "{(Step 1A/33) started" + "; retain2event4xi-started: " + str(retain2event4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4retain2event-to-retain2event4xi: " + str(task4retain2event) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
 

             
    code2ack  = ' '
    code2nack = ' '

    if event4xi is None:
        event4xi = create2event4xi()                                                                            # CREATE EVENT
                                
        message2print = "{(Step 1C/33) retain" + "; event4xi-retain-by-retain2event4xi to: " + str(event4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A1/33) passing" + "; task-passing-to-retain2event4apu: " + str(task4retain2event['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['APU'] = retain2event4apu(task4retain2event['APU'])                                                      # 
         
        message2print = "{(Step A2/33) retain" + "; apu-context-retain-by-retain2event4apu to: " + str(event4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'AZ-'
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-retain2event4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B1/33) passing" + "; task-passing-to-retain2event4bpu: " + str(task4retain2event['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['BPU'] = retain2event4bpu(task4retain2event['BPU'])                                                      # 
         
        message2print = "{(Step B2/33) retain" + "; bpu-context-retain-by-retain2event4bpu to: " + str(event4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'BZ-'
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-retain2event4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C1/33) passing" + "; task-passing-to-retain2event4cpu: " + str(task4retain2event['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['CPU'] = retain2event4cpu(task4retain2event['CPU'])                                                      # 
         
        message2print = "{(Step C2/33) retain" + "; cpu-context-retain-by-retain2event4cpu to: " + str(event4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'CZ-'
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-retain2event4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D1/33) passing" + "; task-passing-to-retain2event4dpu: " + str(task4retain2event['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['DPU'] = retain2event4dpu(task4retain2event['DPU'])                                                      # 
         
        message2print = "{(Step D2/33) retain" + "; dpu-context-retain-by-retain2event4dpu to: " + str(event4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'DZ-'
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-retain2event4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E1/33) passing" + "; task-passing-to-retain2event4epu: " + str(task4retain2event['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['EPU'] = retain2event4epu(task4retain2event['EPU'])                                                      # 
         
        message2print = "{(Step E2/33) retain" + "; epu-context-retain-by-retain2event4epu to: " + str(event4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'EZ-'
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-retain2event4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F1/33) passing" + "; task-passing-to-retain2event4fpu: " + str(task4retain2event['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['FPU'] = retain2event4fpu(task4retain2event['FPU'])                                                      # 
         
        message2print = "{(Step F2/33) retain" + "; fpu-context-retain-by-retain2event4fpu to: " + str(event4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'FZ-'
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-retain2event4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G1/33) passing" + "; task-passing-to-retain2event4gpu: " + str(task4retain2event['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['GPU'] = retain2event4gpu(task4retain2event['GPU'])                                                      # 
         
        message2print = "{(Step G2/33) retain" + "; gpu-context-retain-by-retain2event4gpu to: " + str(event4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'GZ-'
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-retain2event4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H1/33) passing" + "; task-passing-to-retain2event4hpu: " + str(task4retain2event['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['HPU'] = retain2event4hpu(task4retain2event['HPU'])                                                      # 
         
        message2print = "{(Step H2/33) retain" + "; hpu-context-retain-by-retain2event4hpu to: " + str(event4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'HZ-'
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-retain2event4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I1/33) passing" + "; task-passing-to-retain2event4ipu: " + str(task4retain2event['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['IPU'] = retain2event4ipu(task4retain2event['IPU'])                                                      # 
         
        message2print = "{(Step I2/33) retain" + "; ipu-context-retain-by-retain2event4ipu to: " + str(event4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'IZ-'
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-retain2event4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J1/33) passing" + "; task-passing-to-retain2event4jpu: " + str(task4retain2event['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['JPU'] = retain2event4jpu(task4retain2event['JPU'])                                                      # 
         
        message2print = "{(Step J2/33) retain" + "; jpu-context-retain-by-retain2event4jpu to: " + str(event4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'JZ-'
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-retain2event4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K1/33) passing" + "; task-passing-to-retain2event4kpu: " + str(task4retain2event['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['KPU'] = retain2event4kpu(task4retain2event['KPU'])                                                      # 
         
        message2print = "{(Step K2/33) retain" + "; kpu-context-retain-by-retain2event4kpu to: " + str(event4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'KZ-'
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-retain2event4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L1/33) passing" + "; task-passing-to-retain2event4lpu: " + str(task4retain2event['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['LPU'] = retain2event4lpu(task4retain2event['LPU'])                                                      # 
         
        message2print = "{(Step L2/33) retain" + "; lpu-context-retain-by-retain2event4lpu to: " + str(event4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'LZ-'
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-retain2event4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M1/33) passing" + "; task-passing-to-retain2event4mpu: " + str(task4retain2event['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['MPU'] = retain2event4mpu(task4retain2event['MPU'])                                                      # 
         
        message2print = "{(Step M2/33) retain" + "; mpu-context-retain-by-retain2event4mpu to: " + str(event4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'MZ-'
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-retain2event4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N1/33) passing" + "; task-passing-to-retain2event4npu: " + str(task4retain2event['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['NPU'] = retain2event4npu(task4retain2event['NPU'])                                                      # 
         
        message2print = "{(Step N2/33) retain" + "; npu-context-retain-by-retain2event4npu to: " + str(event4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'NZ-'
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-retain2event4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O1/33) passing" + "; task-passing-to-retain2event4opu: " + str(task4retain2event['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['OPU'] = retain2event4opu(task4retain2event['OPU'])                                                      # 
         
        message2print = "{(Step O2/33) retain" + "; opu-context-retain-by-retain2event4opu to: " + str(event4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'OZ-'
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-retain2event4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P1/33) passing" + "; task-passing-to-retain2event4ppu: " + str(task4retain2event['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['PPU'] = retain2event4ppu(task4retain2event['PPU'])                                                      # 
         
        message2print = "{(Step P2/33) retain" + "; ppu-context-retain-by-retain2event4ppu to: " + str(event4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'PZ-'
    except:
        message2print = "{(Step PZ1/33) yielded" + "; pu-yielded-by-retain2event4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q1/33) passing" + "; task-passing-to-retain2event4qpu: " + str(task4retain2event['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['QPU'] = retain2event4qpu(task4retain2event['QPU'])                                                      # 
         
        message2print = "{(Step Q2/33) retain" + "; qpu-context-retain-by-retain2event4qpu to: " + str(event4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'QZ-'
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-retain2event4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R1/33) passing" + "; task-passing-to-retain2event4rpu: " + str(task4retain2event['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['RPU'] = retain2event4rpu(task4retain2event['RPU'])                                                      # 
         
        message2print = "{(Step R2/33) retain" + "; rpu-context-retain-by-retain2event4rpu to: " + str(event4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'RZ-'
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-retain2event4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S1/33) passing" + "; task-passing-to-retain2event4spu: " + str(task4retain2event['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['SPU'] = retain2event4spu(task4retain2event['SPU'])                                                      # 
         
        message2print = "{(Step S2/33) retain" + "; spu-context-retain-by-retain2event4spu to: " + str(event4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'SZ-'
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-retain2event4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T1/33) passing" + "; task-passing-to-retain2event4tpu: " + str(task4retain2event['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['TPU'] = retain2event4tpu(task4retain2event['TPU'])                                                      # 
         
        message2print = "{(Step T2/33) retain" + "; tpu-context-retain-by-retain2event4tpu to: " + str(event4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'TZ-'
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-retain2event4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U1/33) passing" + "; task-passing-to-retain2event4upu: " + str(task4retain2event['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['UPU'] = retain2event4upu(task4retain2event['UPU'])                                                      # 
         
        message2print = "{(Step U2/33) retain" + "; upu-context-retain-by-retain2event4upu to: " + str(event4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'UZ-'
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-retain2event4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V1/33) passing" + "; task-passing-to-retain2event4vpu: " + str(task4retain2event['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['VPU'] = retain2event4vpu(task4retain2event['VPU'])                                                      # 
         
        message2print = "{(Step V2/33) retain" + "; vpu-context-retain-by-retain2event4vpu to: " + str(event4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'VZ-'
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-retain2event4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W1/33) passing" + "; task-passing-to-retain2event4wpu: " + str(task4retain2event['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['WPU'] = retain2event4wpu(task4retain2event['WPU'])                                                      # 
         
        message2print = "{(Step W2/33) retain" + "; wpu-context-retain-by-retain2event4wpu to: " + str(event4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'WZ-'
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-retain2event4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X1/33) passing" + "; task-passing-to-retain2event4xpu: " + str(task4retain2event['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['XPU'] = retain2event4xpu(task4retain2event['XPU'])                                                      # 
         
        message2print = "{(Step X2/33) retain" + "; xpu-context-retain-by-retain2event4xpu to: " + str(event4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'XZ-'
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-retain2event4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y1/33) passing" + "; task-passing-to-retain2event4ypu: " + str(task4retain2event['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['YPU'] = retain2event4ypu(task4retain2event['YPU'])                                                      # 
         
        message2print = "{(Step Y2/33) retain" + "; ypu-context-retain-by-retain2event4ypu to: " + str(event4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'YZ-'
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-retain2event4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z1/33) passing" + "; task-passing-to-retain2event4zpu: " + str(task4retain2event['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['ZPU'] = retain2event4zpu(task4retain2event['ZPU'])                                                      # 
         
        message2print = "{(Step Z2/33) retain" + "; zpu-context-retain-by-retain2event4zpu to: " + str(event4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'ZZ-'
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-retain2event4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; event4xi-returning-by-retain2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return event4xi

#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2event4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF EVENT5TEST - TRYING TO TRACE EVENT4XI ', time4xi())
#     try:                               
#         response4trace2event = trace2event4xi()                                                       
#         print('(Step 4B/33) OF EVENT5TEST - RESPONSE4TRACE2EVENT : ', response4trace2event) 
#     except:
#         print('(Step 4Z1/33) OF EVENT5TEST *** FAILED TO TRACE EVENT4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def trace2event4xi(task4trace2event=None):

    '''
    traces event4xi
    '''
    global event4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2event4xi"
    method2print = "trace2event4xi"

    message2print = "{(Step 1A/33) started" + "; trace2event4xi-started: " + str(trace2event4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2event-to-trace2event4xi: " + str(task4trace2event) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    
 
    code2ack  = ' '
    code2nack = ' '

    if event4xi is None:
        event4xi = create2event4xi()                                                                            # CREATE EVENT
                                
        message2print = "{(Step 1C/33) trace" + "; event4xi-trace-by-trace2event4xi to: " + str(event4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A/33) passing" + "; task-passing-to-trace2event4apu: " + str(task4trace2event['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['APU'] = trace2event4apu(task4trace2event['APU'])                                                      # 
         
        message2print = "{(Step A1/33) trace" + "; apu-event-trace-by-trace2event4apu to: " + str(event4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'A1-'
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-trace2event4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B/33) passing" + "; task-passing-to-trace2event4bpu: " + str(task4trace2event['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['BPU'] = trace2event4bpu(task4trace2event['BPU'])                                                      # 
         
        message2print = "{(Step B1/33) trace" + "; bpu-event-trace-by-trace2event4bpu to: " + str(event4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'B1-'
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-trace2event4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C/33) passing" + "; task-passing-to-trace2event4cpu: " + str(task4trace2event['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['CPU'] = trace2event4cpu(task4trace2event['CPU'])                                                      # 
         
        message2print = "{(Step C1/33) trace" + "; cpu-event-trace-by-trace2event4cpu to: " + str(event4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'C1-'
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-trace2event4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D/33) passing" + "; task-passing-to-trace2event4dpu: " + str(task4trace2event['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['DPU'] = trace2event4dpu(task4trace2event['DPU'])                                                      # 
         
        message2print = "{(Step D1/33) trace" + "; dpu-event-trace-by-trace2event4dpu to: " + str(event4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'D1-'
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-trace2event4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E/33) passing" + "; task-passing-to-trace2event4epu: " + str(task4trace2event['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['EPU'] = trace2event4epu(task4trace2event['EPU'])                                                      # 
         
        message2print = "{(Step E1/33) trace" + "; epu-event-trace-by-trace2event4epu to: " + str(event4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'E1-'
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-trace2event4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F/33) passing" + "; task-passing-to-trace2event4fpu: " + str(task4trace2event['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['FPU'] = trace2event4fpu(task4trace2event['FPU'])                                                      # 
         
        message2print = "{(Step F1/33) trace" + "; fpu-event-trace-by-trace2event4fpu to: " + str(event4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'F1-'
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-trace2event4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G/33) passing" + "; task-passing-to-trace2event4gpu: " + str(task4trace2event['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['GPU'] = trace2event4gpu(task4trace2event['GPU'])                                                      # 
         
        message2print = "{(Step G1/33) trace" + "; gpu-event-trace-by-trace2event4gpu to: " + str(event4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'G1-'
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-trace2event4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H/33) passing" + "; task-passing-to-trace2event4hpu: " + str(task4trace2event['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['HPU'] = trace2event4hpu(task4trace2event['HPU'])                                                      # 
         
        message2print = "{(Step H1/33) trace" + "; hpu-event-trace-by-trace2event4hpu to: " + str(event4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'H1-'
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-trace2event4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I/33) passing" + "; task-passing-to-trace2event4ipu: " + str(task4trace2event['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['IPU'] = trace2event4ipu(task4trace2event['IPU'])                                                      # 
         
        message2print = "{(Step I1/33) trace" + "; ipu-event-trace-by-trace2event4ipu to: " + str(event4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'I1-'
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-trace2event4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J/33) passing" + "; task-passing-to-trace2event4jpu: " + str(task4trace2event['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['JPU'] = trace2event4jpu(task4trace2event['JPU'])                                                      # 
         
        message2print = "{(Step J1/33) trace" + "; jpu-event-trace-by-trace2event4jpu to: " + str(event4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'J1-'
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-trace2event4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K/33) passing" + "; task-passing-to-trace2event4kpu: " + str(task4trace2event['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['KPU'] = trace2event4kpu(task4trace2event['KPU'])                                                      # 
         
        message2print = "{(Step K1/33) trace" + "; kpu-event-trace-by-trace2event4kpu to: " + str(event4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'K1-'
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-trace2event4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L/33) passing" + "; task-passing-to-trace2event4lpu: " + str(task4trace2event['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['LPU'] = trace2event4lpu(task4trace2event['LPU'])                                                      # 
         
        message2print = "{(Step L1/33) trace" + "; lpu-event-trace-by-trace2event4lpu to: " + str(event4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + '1-'
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-trace2event4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M/33) passing" + "; task-passing-to-trace2event4mpu: " + str(task4trace2event['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['MPU'] = trace2event4mpu(task4trace2event['MPU'])                                                      # 
         
        message2print = "{(Step M1/33) trace" + "; mpu-event-trace-by-trace2event4mpu to: " + str(event4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'M1-'
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-trace2event4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N/33) passing" + "; task-passing-to-trace2event4npu: " + str(task4trace2event['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['NPU'] = trace2event4npu(task4trace2event['NPU'])                                                      # 
         
        message2print = "{(Step N1/33) trace" + "; npu-event-trace-by-trace2event4npu to: " + str(event4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'N1-'
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-trace2event4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O/33) passing" + "; task-passing-to-trace2event4opu: " + str(task4trace2event['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['OPU'] = trace2event4opu(task4trace2event['OPU'])                                                      # 
         
        message2print = "{(Step O1/33) trace" + "; opu-event-trace-by-trace2event4opu to: " + str(event4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'O1-'
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-trace2event4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P/33) passing" + "; task-passing-to-trace2event4ppu: " + str(task4trace2event['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['PPU'] = trace2event4ppu(task4trace2event['PPU'])                                                      # 
         
        message2print = "{(Step P1/33) trace" + "; ppu-event-trace-by-trace2event4ppu to: " + str(event4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'P1-'
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-trace2event4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q/33) passing" + "; task-passing-to-trace2event4qpu: " + str(task4trace2event['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['QPU'] = trace2event4qpu(task4trace2event['QPU'])                                                      # 
         
        message2print = "{(Step Q1/33) trace" + "; qpu-event-trace-by-trace2event4qpu to: " + str(event4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Q1-'
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-trace2event4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R/33) passing" + "; task-passing-to-trace2event4rpu: " + str(task4trace2event['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['RPU'] = trace2event4rpu(task4trace2event['RPU'])                                                      # 
         
        message2print = "{(Step R1/33) trace" + "; rpu-event-trace-by-trace2event4rpu to: " + str(event4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'R1-'
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-trace2event4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S/33) passing" + "; task-passing-to-trace2event4spu: " + str(task4trace2event['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['SPU'] = trace2event4spu(task4trace2event['SPU'])                                                      # 
         
        message2print = "{(Step S1/33) trace" + "; spu-event-trace-by-trace2event4spu to: " + str(event4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'S1-'
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-trace2event4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T/33) passing" + "; task-passing-to-trace2event4tpu: " + str(task4trace2event['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['TPU'] = trace2event4tpu(task4trace2event['TPU'])                                                      # 
         
        message2print = "{(Step T1/33) trace" + "; tpu-event-trace-by-trace2event4tpu to: " + str(event4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'T1-'
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-trace2event4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U/33) passing" + "; task-passing-to-trace2event4upu: " + str(task4trace2event['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['UPU'] = trace2event4upu(task4trace2event['UPU'])                                                      # 
         
        message2print = "{(Step U1/33) trace" + "; upu-event-trace-by-trace2event4upu to: " + str(event4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'U1-'
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-trace2event4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V/33) passing" + "; task-passing-to-trace2event4vpu: " + str(task4trace2event['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['VPU'] = trace2event4vpu(task4trace2event['VPU'])                                                      # 
         
        message2print = "{(Step V1/33) trace" + "; vpu-event-trace-by-trace2event4vpu to: " + str(event4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'V1-'
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-trace2event4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W/33) passing" + "; task-passing-to-trace2event4wpu: " + str(task4trace2event['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['WPU'] = trace2event4wpu(task4trace2event['WPU'])                                                      # 
         
        message2print = "{(Step W1/33) trace" + "; wpu-event-trace-by-trace2event4wpu to: " + str(event4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'W1-'
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-trace2event4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X/33) passing" + "; task-passing-to-trace2event4xpu: " + str(task4trace2event['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['XPU'] = trace2event4xpu(task4trace2event['XPU'])                                                      # 
         
        message2print = "{(Step X1/33) trace" + "; xpu-event-trace-by-trace2event4xpu to: " + str(event4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'X1-'
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-trace2event4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y/33) passing" + "; task-passing-to-trace2event4ypu: " + str(task4trace2event['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['YPU'] = trace2event4ypu(task4trace2event['YPU'])                                                      # 
         
        message2print = "{(Step Y1/33) trace" + "; ypu-event-trace-by-trace2event4ypu to: " + str(event4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Y1-'
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-trace2event4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z/33) passing" + "; task-passing-to-trace2event4zpu: " + str(task4trace2event['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['ZPU'] = trace2event4zpu(task4trace2event['ZPU'])                                                      # 
         
        message2print = "{(Step Z1/33) trace" + "; zpu-event-trace-by-trace2event4zpu to: " + str(event4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Z1-'
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-trace2event4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; event4xi-returning-by-trace2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    
    return event4xi

            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "wait2event4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF EVENT5TEST - TRYING TO WAIT EVENT4XI ', time4xi())
#     try:                               
#         response4wait2event = wait2event4xi()                                                       
#         print('(Step 4B/33) OF EVENT5TEST - RESPONSE4WAIT2EVENT : ', response4wait2event) 
#     except:
#         print('(Step 4Z1/33) OF EVENT5TEST *** FAILED TO WAIT EVENT4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def wait2event4xi(task4wait2event=None):

    '''
    waits event4xi
    '''
    global event4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "wait2event4xi"
    method2print = "wait2event4xi"

    message2print = "{(Step 1A/33) started" + "; wait2event4xi-started: " + str(wait2event4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
             
    message2print = "{(Step 1B/33) passed" + "; task4wait2event-to-wait2event4xi: " + str(task4wait2event) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    
 
    code2ack  = ' '
    code2nack = ' '

    if event4xi is None:
        event4xi = create2event4xi()                                                                            # CREATE EVENT
                                
        message2print = "{(Step 1C/33) wait" + "; event4xi-wait-by-wait2event4xi to: " + str(event4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A/33) passing" + "; task-passing-to-wait2event4apu: " + str(task4wait2event['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['APU'] = wait2event4apu(task4wait2event['APU'])                                                      # 
         
        message2print = "{(Step A1/33) wait" + "; apu-event-wait-by-wait2event4apu to: " + str(event4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'A1-'
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-wait2event4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B/33) passing" + "; task-passing-to-wait2event4bpu: " + str(task4wait2event['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['BPU'] = wait2event4bpu(task4wait2event['BPU'])                                                      # 
         
        message2print = "{(Step B1/33) wait" + "; bpu-event-wait-by-wait2event4bpu to: " + str(event4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'B1-'
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-wait2event4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C/33) passing" + "; task-passing-to-wait2event4cpu: " + str(task4wait2event['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['CPU'] = wait2event4cpu(task4wait2event['CPU'])                                                      # 
         
        message2print = "{(Step C1/33) wait" + "; cpu-event-wait-by-wait2event4cpu to: " + str(event4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'C1-'
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-wait2event4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D/33) passing" + "; task-passing-to-wait2event4dpu: " + str(task4wait2event['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['DPU'] = wait2event4dpu(task4wait2event['DPU'])                                                      # 
         
        message2print = "{(Step D1/33) wait" + "; dpu-event-wait-by-wait2event4dpu to: " + str(event4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'D1-'
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-wait2event4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E/33) passing" + "; task-passing-to-wait2event4epu: " + str(task4wait2event['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['EPU'] = wait2event4epu(task4wait2event['EPU'])                                                      # 
         
        message2print = "{(Step E1/33) wait" + "; epu-event-wait-by-wait2event4epu to: " + str(event4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'E1-'
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-wait2event4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F/33) passing" + "; task-passing-to-wait2event4fpu: " + str(task4wait2event['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['FPU'] = wait2event4fpu(task4wait2event['FPU'])                                                      # 
         
        message2print = "{(Step F1/33) wait" + "; fpu-event-wait-by-wait2event4fpu to: " + str(event4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'F1-'
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-wait2event4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G/33) passing" + "; task-passing-to-wait2event4gpu: " + str(task4wait2event['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['GPU'] = wait2event4gpu(task4wait2event['GPU'])                                                      # 
         
        message2print = "{(Step G1/33) wait" + "; gpu-event-wait-by-wait2event4gpu to: " + str(event4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'G1-'
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-wait2event4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H/33) passing" + "; task-passing-to-wait2event4hpu: " + str(task4wait2event['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['HPU'] = wait2event4hpu(task4wait2event['HPU'])                                                      # 
         
        message2print = "{(Step H1/33) wait" + "; hpu-event-wait-by-wait2event4hpu to: " + str(event4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'H1-'
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-wait2event4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I/33) passing" + "; task-passing-to-wait2event4ipu: " + str(task4wait2event['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['IPU'] = wait2event4ipu(task4wait2event['IPU'])                                                      # 
         
        message2print = "{(Step I1/33) wait" + "; ipu-event-wait-by-wait2event4ipu to: " + str(event4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'I1-'
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-wait2event4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J/33) passing" + "; task-passing-to-wait2event4jpu: " + str(task4wait2event['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['JPU'] = wait2event4jpu(task4wait2event['JPU'])                                                      # 
         
        message2print = "{(Step J1/33) wait" + "; jpu-event-wait-by-wait2event4jpu to: " + str(event4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'J1-'
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-wait2event4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K/33) passing" + "; task-passing-to-wait2event4kpu: " + str(task4wait2event['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['KPU'] = wait2event4kpu(task4wait2event['KPU'])                                                      # 
         
        message2print = "{(Step K1/33) wait" + "; kpu-event-wait-by-wait2event4kpu to: " + str(event4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'K1-'
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-wait2event4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L/33) passing" + "; task-passing-to-wait2event4lpu: " + str(task4wait2event['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['LPU'] = wait2event4lpu(task4wait2event['LPU'])                                                      # 
         
        message2print = "{(Step L1/33) wait" + "; lpu-event-wait-by-wait2event4lpu to: " + str(event4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + '1-'
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-wait2event4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M/33) passing" + "; task-passing-to-wait2event4mpu: " + str(task4wait2event['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['MPU'] = wait2event4mpu(task4wait2event['MPU'])                                                      # 
         
        message2print = "{(Step M1/33) wait" + "; mpu-event-wait-by-wait2event4mpu to: " + str(event4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'M1-'
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-wait2event4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N/33) passing" + "; task-passing-to-wait2event4npu: " + str(task4wait2event['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['NPU'] = wait2event4npu(task4wait2event['NPU'])                                                      # 
         
        message2print = "{(Step N1/33) wait" + "; npu-event-wait-by-wait2event4npu to: " + str(event4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'N1-'
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-wait2event4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O/33) passing" + "; task-passing-to-wait2event4opu: " + str(task4wait2event['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['OPU'] = wait2event4opu(task4wait2event['OPU'])                                                      # 
         
        message2print = "{(Step O1/33) wait" + "; opu-event-wait-by-wait2event4opu to: " + str(event4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'O1-'
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-wait2event4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P/33) passing" + "; task-passing-to-wait2event4ppu: " + str(task4wait2event['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['PPU'] = wait2event4ppu(task4wait2event['PPU'])                                                      # 
         
        message2print = "{(Step P1/33) wait" + "; ppu-event-wait-by-wait2event4ppu to: " + str(event4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'P1-'
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-wait2event4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q/33) passing" + "; task-passing-to-wait2event4qpu: " + str(task4wait2event['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['QPU'] = wait2event4qpu(task4wait2event['QPU'])                                                      # 
         
        message2print = "{(Step Q1/33) wait" + "; qpu-event-wait-by-wait2event4qpu to: " + str(event4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Q1-'
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-wait2event4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R/33) passing" + "; task-passing-to-wait2event4rpu: " + str(task4wait2event['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['RPU'] = wait2event4rpu(task4wait2event['RPU'])                                                      # 
         
        message2print = "{(Step R1/33) wait" + "; rpu-event-wait-by-wait2event4rpu to: " + str(event4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'R1-'
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-wait2event4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S/33) passing" + "; task-passing-to-wait2event4spu: " + str(task4wait2event['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['SPU'] = wait2event4spu(task4wait2event['SPU'])                                                      # 
         
        message2print = "{(Step S1/33) wait" + "; spu-event-wait-by-wait2event4spu to: " + str(event4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'S1-'
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-wait2event4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T/33) passing" + "; task-passing-to-wait2event4tpu: " + str(task4wait2event['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['TPU'] = wait2event4tpu(task4wait2event['TPU'])                                                      # 
         
        message2print = "{(Step T1/33) wait" + "; tpu-event-wait-by-wait2event4tpu to: " + str(event4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'T1-'
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-wait2event4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U/33) passing" + "; task-passing-to-wait2event4upu: " + str(task4wait2event['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['UPU'] = wait2event4upu(task4wait2event['UPU'])                                                      # 
         
        message2print = "{(Step U1/33) wait" + "; upu-event-wait-by-wait2event4upu to: " + str(event4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'U1-'
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-wait2event4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V/33) passing" + "; task-passing-to-wait2event4vpu: " + str(task4wait2event['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['VPU'] = wait2event4vpu(task4wait2event['VPU'])                                                      # 
         
        message2print = "{(Step V1/33) wait" + "; vpu-event-wait-by-wait2event4vpu to: " + str(event4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'V1-'
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-wait2event4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W/33) passing" + "; task-passing-to-wait2event4wpu: " + str(task4wait2event['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['WPU'] = wait2event4wpu(task4wait2event['WPU'])                                                      # 
         
        message2print = "{(Step W1/33) wait" + "; wpu-event-wait-by-wait2event4wpu to: " + str(event4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'W1-'
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-wait2event4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X/33) passing" + "; task-passing-to-wait2event4xpu: " + str(task4wait2event['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['XPU'] = wait2event4xpu(task4wait2event['XPU'])                                                      # 
         
        message2print = "{(Step X1/33) wait" + "; xpu-event-wait-by-wait2event4xpu to: " + str(event4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'X1-'
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-wait2event4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y/33) passing" + "; task-passing-to-wait2event4ypu: " + str(task4wait2event['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['YPU'] = wait2event4ypu(task4wait2event['YPU'])                                                      # 
         
        message2print = "{(Step Y1/33) wait" + "; ypu-event-wait-by-wait2event4ypu to: " + str(event4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Y1-'
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-wait2event4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z/33) passing" + "; task-passing-to-wait2event4zpu: " + str(task4wait2event['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['ZPU'] = wait2event4zpu(task4wait2event['ZPU'])                                                      # 
         
        message2print = "{(Step Z1/33) wait" + "; zpu-event-wait-by-wait2event4zpu to: " + str(event4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Z1-'
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-wait2event4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; event4xi-returning-by-wait2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    
    return event4xi

            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2event4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF EVENT5TEST - TRYING TO RELEASE EVENT4XI ', time4xi())
#     try:                               
#         response4release2event = release2event4xi()                                                       
#         print('(Step 4B/33) OF EVENT5TEST - RESPONSE4SET2EVENT : ', response4release2event) 
#     except:
#         print('(Step 4Z1/33) OF EVENT5TEST *** FAILED TO RELEASE EVENT4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def release2event4xi(task4release2event=None):

    '''
    releases event4xi
    '''
    global event4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2event4xi"
    method2print = "release2event4xi"

    message2print = "{(Step 1A/33) started" + "; release2event4xi-started: " + str(release2event4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4release2event-to-release2event4xi: " + str(task4release2event) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 

             
    code2ack  = ' '
    code2nack = ' '

    if event4xi is None:
        event4xi = create2event4xi()                                                                            # CREATE EVENT
                                
        message2print = "{(Step 1C/33) release" + "; event4xi-release-by-release2event4xi to: " + str(event4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        


    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A1/33) passing" + "; task-passing-to-release2event4apu: " + str(task4release2event['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['APU'] = release2event4apu(task4release2event['APU'])                                                      # 
         
        message2print = "{(Step A2/33) release" + "; apu-context-release-by-release2event4apu to: " + str(event4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'A2-'
    except:
        message2print = "{(Step AZ/33) yielded" + "; apu-yielded-by-release2event4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B1/33) passing" + "; task-passing-to-release2event4bpu: " + str(task4release2event['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['BPU'] = release2event4bpu(task4release2event['BPU'])                                                      # 
         
        message2print = "{(Step B2/33) release" + "; bpu-context-release-by-release2event4bpu to: " + str(event4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'B2-'
    except:
        message2print = "{(Step BZ/33) yielded" + "; bpu-yielded-by-release2event4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C1/33) passing" + "; task-passing-to-release2event4cpu: " + str(task4release2event['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['CPU'] = release2event4cpu(task4release2event['CPU'])                                                      # 
         
        message2print = "{(Step C2/33) release" + "; cpu-context-release-by-release2event4cpu to: " + str(event4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'C2-'
    except:
        message2print = "{(Step CZ/33) yielded" + "; cpu-yielded-by-release2event4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D1/33) passing" + "; task-passing-to-release2event4dpu: " + str(task4release2event['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['DPU'] = release2event4dpu(task4release2event['DPU'])                                                      # 
         
        message2print = "{(Step D2/33) release" + "; dpu-context-release-by-release2event4dpu to: " + str(event4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'D2-'
    except:
        message2print = "{(Step DZ/33) yielded" + "; dpu-yielded-by-release2event4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E1/33) passing" + "; task-passing-to-release2event4epu: " + str(task4release2event['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['EPU'] = release2event4epu(task4release2event['EPU'])                                                      # 
         
        message2print = "{(Step E2/33) release" + "; epu-context-release-by-release2event4epu to: " + str(event4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'E2-'
    except:
        message2print = "{(Step EZ/33) yielded" + "; epu-yielded-by-release2event4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F1/33) passing" + "; task-passing-to-release2event4fpu: " + str(task4release2event['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['FPU'] = release2event4fpu(task4release2event['FPU'])                                                      # 
         
        message2print = "{(Step F2/33) release" + "; fpu-context-release-by-release2event4fpu to: " + str(event4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'F2-'
    except:
        message2print = "{(Step FZ/33) yielded" + "; fpu-yielded-by-release2event4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G1/33) passing" + "; task-passing-to-release2event4gpu: " + str(task4release2event['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['GPU'] = release2event4gpu(task4release2event['GPU'])                                                      # 
         
        message2print = "{(Step G2/33) release" + "; gpu-context-release-by-release2event4gpu to: " + str(event4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'G2-'
    except:
        message2print = "{(Step GZ/33) yielded" + "; gpu-yielded-by-release2event4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H1/33) passing" + "; task-passing-to-release2event4hpu: " + str(task4release2event['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['HPU'] = release2event4hpu(task4release2event['HPU'])                                                      # 
         
        message2print = "{(Step H2/33) release" + "; hpu-context-release-by-release2event4hpu to: " + str(event4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'H2-'
    except:
        message2print = "{(Step HZ/33) yielded" + "; hpu-yielded-by-release2event4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I1/33) passing" + "; task-passing-to-release2event4ipu: " + str(task4release2event['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['IPU'] = release2event4ipu(task4release2event['IPU'])                                                      # 
         
        message2print = "{(Step I2/33) release" + "; ipu-context-release-by-release2event4ipu to: " + str(event4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'I2-'
    except:
        message2print = "{(Step IZ/33) yielded" + "; ipu-yielded-by-release2event4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J1/33) passing" + "; task-passing-to-release2event4jpu: " + str(task4release2event['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['JPU'] = release2event4jpu(task4release2event['JPU'])                                                      # 
         
        message2print = "{(Step J2/33) release" + "; jpu-context-release-by-release2event4jpu to: " + str(event4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'J2-'
    except:
        message2print = "{(Step JZ/33) yielded" + "; jpu-yielded-by-release2event4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K1/33) passing" + "; task-passing-to-release2event4kpu: " + str(task4release2event['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['KPU'] = release2event4kpu(task4release2event['KPU'])                                                      # 
         
        message2print = "{(Step K2/33) release" + "; kpu-context-release-by-release2event4kpu to: " + str(event4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'K2-'
    except:
        message2print = "{(Step KZ/33) yielded" + "; kpu-yielded-by-release2event4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L1/33) passing" + "; task-passing-to-release2event4lpu: " + str(task4release2event['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['LPU'] = release2event4lpu(task4release2event['LPU'])                                                      # 
         
        message2print = "{(Step L2/33) release" + "; lpu-context-release-by-release2event4lpu to: " + str(event4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'L2-'
    except:
        message2print = "{(Step LZ/33) yielded" + "; lpu-yielded-by-release2event4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M1/33) passing" + "; task-passing-to-release2event4mpu: " + str(task4release2event['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['MPU'] = release2event4mpu(task4release2event['MPU'])                                                      # 
         
        message2print = "{(Step M2/33) release" + "; mpu-context-release-by-release2event4mpu to: " + str(event4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'M2-'
    except:
        message2print = "{(Step MZ/33) yielded" + "; mpu-yielded-by-release2event4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N1/33) passing" + "; task-passing-to-release2event4npu: " + str(task4release2event['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['NPU'] = release2event4npu(task4release2event['NPU'])                                                      # 
         
        message2print = "{(Step N2/33) release" + "; npu-context-release-by-release2event4npu to: " + str(event4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'N2-'
    except:
        message2print = "{(Step NZ/33) yielded" + "; npu-yielded-by-release2event4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O1/33) passing" + "; task-passing-to-release2event4opu: " + str(task4release2event['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['OPU'] = release2event4opu(task4release2event['OPU'])                                                      # 
         
        message2print = "{(Step O2/33) release" + "; opu-context-release-by-release2event4opu to: " + str(event4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'O2-'
    except:
        message2print = "{(Step OZ/33) yielded" + "; opu-yielded-by-release2event4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P1/33) passing" + "; task-passing-to-release2event4ppu: " + str(task4release2event['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['PPU'] = release2event4ppu(task4release2event['PPU'])                                                      # 
         
        message2print = "{(Step P2/33) release" + "; ppu-context-release-by-release2event4ppu to: " + str(event4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'P2-'
    except:
        message2print = "{(Step PZ/33) yielded" + "; ppu-yielded-by-release2event4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q1/33) passing" + "; task-passing-to-release2event4qpu: " + str(task4release2event['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['QPU'] = release2event4qpu(task4release2event['QPU'])                                                      # 
         
        message2print = "{(Step Q2/33) release" + "; qpu-context-release-by-release2event4qpu to: " + str(event4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'Q2-'
    except:
        message2print = "{(Step QZ/33) yielded" + "; qpu-yielded-by-release2event4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R1/33) passing" + "; task-passing-to-release2event4rpu: " + str(task4release2event['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['RPU'] = release2event4rpu(task4release2event['RPU'])                                                      # 
         
        message2print = "{(Step R2/33) release" + "; rpu-context-release-by-release2event4rpu to: " + str(event4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'R2-'
    except:
        message2print = "{(Step RZ/33) yielded" + "; rpu-yielded-by-release2event4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S1/33) passing" + "; task-passing-to-release2event4spu: " + str(task4release2event['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['SPU'] = release2event4spu(task4release2event['SPU'])                                                      # 
         
        message2print = "{(Step S2/33) release" + "; spu-context-release-by-release2event4spu to: " + str(event4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'S2-'
    except:
        message2print = "{(Step SZ/33) yielded" + "; spu-yielded-by-release2event4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T1/33) passing" + "; task-passing-to-release2event4tpu: " + str(task4release2event['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['TPU'] = release2event4tpu(task4release2event['TPU'])                                                      # 
         
        message2print = "{(Step T2/33) release" + "; tpu-context-release-by-release2event4tpu to: " + str(event4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'T2-'
    except:
        message2print = "{(Step TZ/33) yielded" + "; tpu-yielded-by-release2event4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U1/33) passing" + "; task-passing-to-release2event4upu: " + str(task4release2event['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['UPU'] = release2event4upu(task4release2event['UPU'])                                                      # 
         
        message2print = "{(Step U2/33) release" + "; upu-context-release-by-release2event4upu to: " + str(event4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'U2-'
    except:
        message2print = "{(Step UZ/33) yielded" + "; upu-yielded-by-release2event4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V1/33) passing" + "; task-passing-to-release2event4vpu: " + str(task4release2event['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['VPU'] = release2event4vpu(task4release2event['VPU'])                                                      # 
         
        message2print = "{(Step V2/33) release" + "; vpu-context-release-by-release2event4vpu to: " + str(event4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'V2-'
    except:
        message2print = "{(Step VZ/33) yielded" + "; vpu-yielded-by-release2event4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W1/33) passing" + "; task-passing-to-release2event4wpu: " + str(task4release2event['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['WPU'] = release2event4wpu(task4release2event['WPU'])                                                      # 
         
        message2print = "{(Step W2/33) release" + "; wpu-context-release-by-release2event4wpu to: " + str(event4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'W2-'
    except:
        message2print = "{(Step WZ/33) yielded" + "; wpu-yielded-by-release2event4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X1/33) passing" + "; task-passing-to-release2event4xpu: " + str(task4release2event['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['XPU'] = release2event4xpu(task4release2event['XPU'])                                                      # 
         
        message2print = "{(Step X2/33) release" + "; xpu-context-release-by-release2event4xpu to: " + str(event4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'X2-'
    except:
        message2print = "{(Step XZ/33) yielded" + "; xpu-yielded-by-release2event4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y1/33) passing" + "; task-passing-to-release2event4ypu: " + str(task4release2event['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['YPU'] = release2event4ypu(task4release2event['YPU'])                                                      # 
         
        message2print = "{(Step Y2/33) release" + "; ypu-context-release-by-release2event4ypu to: " + str(event4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'Y2-'
    except:
        message2print = "{(Step YZ/33) yielded" + "; ypu-yielded-by-release2event4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z1/33) passing" + "; task-passing-to-release2event4zpu: " + str(task4release2event['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        event4xi ['ZPU'] = release2event4zpu(task4release2event['ZPU'])                                                      # 
         
        message2print = "{(Step Z2/33) release" + "; zpu-context-release-by-release2event4zpu to: " + str(event4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'Z2-'
    except:
        message2print = "{(Step ZZ/33) yielded" + "; zpu-yielded-by-release2event4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; event4xi-returning-by-release2event4xi: " + str(event4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return event4xi

            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2eventinfo4xi" usage = "
#
#    try:                               
#        response4get2eventinfo = get2eventinfo4xi()                                        
#                                                                                                                   
#    except:
#        ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def get2eventinfo4xi():

    '''
    gets event4xi
    '''
    
    global event4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2eventinfo4xi"
    method2print = "get2eventinfo4xi"

    message2print = "{(Step 1A/33) started" + "; get2eventinfo-started: " + str(get2eventinfo4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    cc2xi = None
    try: 
        if event4xi is None:
            # -------------------------------------------------------------------------------------
            # TRY TO CREATE           
            # -------------------------------------------------------------------------------------           
            cc2xi = create2event4xi()
            
            message2print = "{(Step 1B/33) initialized" + "; cc2xi-initialized-by-get2eventinfo to: " + str(cc2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
        else:
            # -------------------------------------------------------------------------------------
            # USE           
            # -------------------------------------------------------------------------------------         
            cc2xi = event4xi 
            
            message2print = "{(Step 1C/33) got" + "; cc2xi-got-by-get2eventinfo: " + str(cc2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
    except:
        try:
            # -------------------------------------------------------------------------------------
            # TRY TO CREATE           
            # -------------------------------------------------------------------------------------           
            cc2xi = create2event4xi()
            
            message2print = "{(Step 1D/33) initialized" + "; cc2xi-initialized-by-get2eventinfo to: " + str(cc2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #              
       
        except:
            # -------------------------------------------------------------------------------------
            # YIELD!        
            # -------------------------------------------------------------------------------------                      
            cc2xi = {}
            
            message2print = "{(Step 1Z/33) yielded" + "; cc2xi-yielded-by-get2eventinfo: " + str(cc2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            
            
    message2print = "{(Step 33/33) returning" + "; cc2xi-returning-by-get2eventinfo: " + str(cc2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return cc2xi
            
#</function4xi> 
 
                                               
# =================================================================================================
#<class4xi class = "Event4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for Event" usage = "OpenCL Event"
#>

# =================================================================================================
class Event4Xi(object): 
    ''' 
    Event4Xi offers  methods for Event
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2event = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'create2event',                    # ACK
    'get2eventinfo',                   # ACK
    'release2event',                   # ACK
    'retain2event',                    # ACK
    'set2event',                       # ACK
    'set2eventcallback',               # ACK
    'trace2event',                     # ACK
    'wait2event',                      # ACK            
    'sense',                           # ACK
    'reason',                          # ACK
    'ace')                             # ACK          
    #"
    #/>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create-of-Event4Xi" usage = "initializes Event4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4create2event = None):
        '''
        _init__ method initializes Event4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "Event4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; create-of-Event4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        message2print = "{(Step 1B/33) borning" + "; cc2xi-of-Event4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-cc2xi-of-Event4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2event-sharing-by-cc2xi-of-Event4Xi: " + str(Event4Xi.classvariable2event)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #              
                                
        message2print = "{(Step 1E/33) passed" + "; task4create2event-passed-to-create-of-Event4Xi: " + str(task4create2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                              
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4create2event-passing-to-create2event4xi-by-create-of-Event4Xi: " + str(task4create2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        cc2xi = create2event4xi(task4create2event)
        
        message2print = "{(Step 2B/33) performed" + "; create2event4xi-performed-by-create-of-Event4Xi: " + str(create2event4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #    
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; cc2xi-of-Event4Xi-activated " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-cc2xi-of-Event4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2event-shared-by-cc2xi-of-Event4Xi: " + str(Event4Xi.classvariable2event)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #            
       
        message2print = "{(Step 3D/33) returning" + "; create-of-Event4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2event-of-Event4Xi" usage = "initializes objects of Event4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def create2event(self, task4create2event = None):
        '''
        create2event method creates event for Event4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)            
        # -----------------------------------------------------------------------------------------              
        class2print = "Event4Xi"
        method2print = "create2event"
                      
        message2print = "{(Step 1A/33) started" + "; create2event-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4create2event-passed-to-create2event-of-Event4Xi: " + str(task4create2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                  
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2event-passing-to-create2event4xi-by-create-of-Event4Xi: " + str(task4create2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
  
        cc2xi = create2event4xi(task4create2event)

        message2print = "{(Step 2B/33) performed" + "; create2event4xi-performed-by-create2event-of-Event4Xi: " + str(create2event4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; cc2xi-returning-by-create2event-of-Event4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return cc2xi
                                
                            
    #</methodize4xi>


        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2event-of-Event4Xi" usage = "sets objects of Event4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def set2event(self, task4set2event = None):
        '''
        set2event method sets objects of Event4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Event4Xi"
        method2print = "set2event"
                     
        message2print = "{(Step 1A/33) started" + "; set2event-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2event-passed-to-set2event-of-Event4Xi: " + str(task4set2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2event-passing-to-set2event4xi-by-set2event-of-Event4Xi: " + str(task4set2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #   
                
  
        cc2xi = set2event4xi(task4set2event)

        message2print = "{(Step 2B/33) performed" + "; set2event4xi-performed-by-set2event-of-Event4Xi: " + str(set2event4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; cc2xi-returning-by-set2event-of-Event4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        return cc2xi

    #</methodize4xi>
 

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2eventcallback-of-Event4Xi" usage = "sets callback to objects of Event4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def set2eventcallback(self, task4set2eventcallback = None):
        '''
        set2eventcallback method sets callback to objects of Event4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Event4Xi"
        method2print = "set2eventcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2eventcallback-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2eventcallback-passed-to-set2eventcallback-of-Event4Xi: " + str(task4set2eventcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2eventcallback-passing-to-set2eventcallback4xi-by-set2eventcallback-of-Event4Xi: " + str(task4set2eventcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #   
                
  
        cc2xi = set2eventcallback4xi(task4set2eventcallback)

        message2print = "{(Step 2B/33) performed" + "; set2eventcallback4xi-performed-by-set2eventcallback-of-Event4Xi: " + str(set2eventcallback4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; cc2xi-returning-by-set2eventcallback-of-Event4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        return cc2xi

    #</methodize4xi> 
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2event-of-Event4Xi" usage = "traces objects of Event4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2event(self, task4trace2event = None):
        '''
        trace2event method traces objects of Event4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Event4Xi"
        method2print = "trace2event"
                     
        message2print = "{(Step 1A/33) started" + "; trace2event-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2event-passed-to-trace2event-of-Event4Xi: " + str(task4trace2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2event-passing-to-trace2event4xi-by-trace2event-of-Event4Xi: " + str(task4trace2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #   
                
  
        cc2xi = trace2event4xi(task4trace2event)

        message2print = "{(Step 2B/33) performed" + "; trace2event4xi-performed-by-trace2event-of-Event4Xi: " + str(trace2event4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; cc2xi-returning-by-trace2event-of-Event4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        return cc2xi

    #</methodize4xi>        
       

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "wait2event-of-Event4Xi" usage = "waits objects of Event4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def wait2event(self, task4wait2event = None):
        '''
        wait2event method waits objects of Event4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Event4Xi"
        method2print = "wait2event"
                     
        message2print = "{(Step 1A/33) started" + "; wait2event-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4wait2event-passed-to-wait2event-of-Event4Xi: " + str(task4wait2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4wait2event-passing-to-wait2event4xi-by-wait2event-of-Event4Xi: " + str(task4wait2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #   
                
  
        cc2xi = wait2event4xi(task4wait2event)

        message2print = "{(Step 2B/33) performed" + "; wait2event4xi-performed-by-wait2event-of-Event4Xi: " + str(wait2event4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; cc2xi-returning-by-wait2event-of-Event4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        return cc2xi


    #</methodize4xi>
    
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2event-of-Event4Xi" usage = "releases objects of Event4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def release2event(self, task4release2event = None):
        '''
        release2event method releases objects of Event4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Event4Xi"
        method2print = "release2event"
                     
        message2print = "{(Step 1A/33) started" + "; release2event-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2event-passed-to-release2event-of-Event4Xi: " + str(task4release2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                          
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2event-passing-to-release2event4xi-by-release2event-of-Event4Xi: " + str(task4release2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #    
                
  
        cc2xi = release2event4xi(task4release2event)

        message2print = "{(Step 2B/33) performed" + "; release2event4xi-performed-by-release2event-of-Event4Xi: " + str(release2event4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; cc2xi-returning-by-release2event-of-Event4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        
        return cc2xi                                
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2event-of-Event4Xi" usage = "retains objects of Event4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2event(self, task4retain2event = None):
        '''
        retain2event method retains objects of Event4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Event4Xi"
        method2print = "retain2event"
                     
        message2print = "{(Step 1A/33) started" + "; retain2event-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2event-passed-to-retain2event-of-Event4Xi: " + str(task4retain2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2event-passing-to-retain2event4xi-by-retain2event-of-Event4Xi: " + str(task4retain2event) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #   
                
  
        cc2xi = retain2event4xi(task4retain2event)

        message2print = "{(Step 2B/33) performed" + "; retain2event4xi-performed-by-retain2event-of-Event4Xi: " + str(retain2event4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; cc2xi-returning-by-retain2event-of-Event4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
                
        return cc2xi                                
        
                                    
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2eventinfo-of-Event4Xi" usage = "gets objects of Event4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def get2eventinfo(self):
        '''
        get2eventinfo method gets objects of Event4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Event4Xi"
        method2print = "get2eventinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2eventinfo-of-Event4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # 
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        cc2xi = get2eventinfo4xi()
        
        message2print = "{(Step 2A/33) returning" + "; cc2xi-returning-by-get2eventinfo-of-Event4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # 
        
        return cc2xi
                                
                            
    #</methodize4xi>                                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Event4Xi" usage = "senses Event4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Event4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Event4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; Event4Xi-sensing-by-sense-of-Event4Xi: " + str(Event4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #         
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-Event4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2event-of-Event4Xi'] = Event4Xi.classvariable2event
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-Event4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; Event4Xi-sensed-by-sense-of-Event4Xi: " + str(Event4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-Event4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # {'object': <event4xi.Event4Xi object at 0x0000000003E21C18>, 'classvariable2event-of-Event4Xi': None}; time: 06:04:05 05/21/11 Pacific Daylight Time}
        
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Event4Xi" usage = "reasons Event4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Event4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Event4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; Event4Xi-reasoning-by-reason-of-Event4Xi: " + str(Event4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-Event4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-Event4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-Event4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; Event4Xi-reasoned-by-reason-of-Event4Xi: " + str(Event4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-Event4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # {'object-reason-object4xi': <event4xi.Event4Xi object at 0x0000000003E21C18>, 'time-reason-of-Event4Xi': '06:04:05 05/21/11 Pacific Daylight Time'}; time: 06:04:05 05/21/11 Pacific Daylight Time}

          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Event4Xi" usage = "aces Event4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Event4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'Event4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; Event4Xi-acing-by-ace-of-Event4Xi: " + str(Event4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #  
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-Event4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['time-ace-of-Event4Xi'] = time4xi()
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-Event4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; Event4Xi-aced-by-ace-of-Event4Xi: " + str(Event4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-Event4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        #                        
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   get2eventinfo4xi5test.txt
#   sense-test-get2eventinfo4xi.xml
#   reason-test-get2eventinfo4xi.xml
#   ace-test-get2eventinfo4xi.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of event4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
